/*!
 * The MIT License (MIT)
 * 
 * Copyright (c) 2015-2017 Diffeo Inc. (Dossier Stack)
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("htmlhighlighter", [], factory);
	else if(typeof exports === 'object')
		exports["htmlhighlighter"] = factory();
	else
		root["htmlhighlighter"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// identity function for calling harmony imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 19);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _globals = __webpack_require__(5);

var _globals2 = _interopRequireDefault(_globals);

var _dom = __webpack_require__(1);

var dom = _interopRequireWildcard(_dom);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Class responsible for building and keeping a convenient representation
 * of the text present in an HTML DOM sub-tree.
 */
var TextContent = function () {

  /**
   * Class constructor
   * @param {Node|jQuery} root - Reference to a DOM element
   */
  function TextContent(root) {
    _classCallCheck(this, TextContent);

    this.root = root;
    this.text = '';
    this.markers = [];
    this.refresh();
  }

  /**
   * Refresh internal representation of the text
   *
   * The internal representation of the text present in the DOM sub-tree of the `root` consists of
   * an array of global offsets for every text node in the document, and a reference to the
   * corresponding text node, stored in marker descriptors. In addition, a regular string (`text`)
   * holds the text contents of the document to enable text-based searches.
   *
   * A marker descriptor is of the form:
   * ```
   * {
   *   node:   Node      // reference to text node
   *   offset: integer   // global offset
   * }
   * ```
   *
   * Should only be invoked when the HTML structure mutates, e.g. a new document is loaded.
   * */

  // FIXME: add type


  _createClass(TextContent, [{
    key: 'refresh',
    value: function refresh() {
      this.text = '';
      var markers = this.markers = [];
      var offset = this.visit_(this.root, 0);

      // Sanity check
      if (_globals2.default.debugging) {
        if (this.markers.length !== 0) {
          var marker = markers[markers.length - 1];
          if (offset - marker.node.nodeValue.length !== marker.offset) {
            throw new Error('Invalid state detected: offset mismatch');
          }
        }
      }
    }

    /**
     * Truncate text node
     *
     * Truncates a text node given by `marker` by turning it into 2 or 3 text nodes, with one of them
     * used for highlighting purposes.
     *
     * If `start == 0` and `end == text.length - 1`, no truncation takes place **but** the old text
     * node is replaced by a new one.  This method therefore assumes that the caller has checked to
     * ensure text truncation is required.
     *
     * Truncation takes place in the following manner:
     *
     *  - if `start > 0`: truncate `[ 0 .. start - 1 ]
     *  - create new text node at `[ start .. end ]`
     *  - if `end != text.length - 1`: truncate `[ end .. text.length - 1 ]`
     *
     * @param {Marker} marker - Reference to descriptor of text node to truncate
     * @param {number} start - Offset where to start truncation
     * @param {number} end - Offset where truncation ends
     *
     * @returns {number} Index of marker descriptor
     */

  }, {
    key: 'truncate',
    value: function truncate(marker, start, end) {
      var text = marker.node.nodeValue;
      var index = this.indexOf(marker.offset);
      var old = marker.node; // The old text node

      // Sanity checks
      if (start < 0 || end < 0 || end >= text.length) {
        throw new Error('Invalid truncation parameters');
      }

      // Chars 0..start - 1
      if (start > 0) {
        var _node = document.createTextNode(text.substr(0, start));
        // Since we're creating a new text node out of the old text node, we need to add a new entry
        // to the markers array
        this.markers.splice(index, 0, {
          offset: marker.offset,
          node: dom.insertBefore(_node, marker.node)
        });

        ++index;
      }

      // Chars start..end
      // ----------------
      // We don't need to add a new entry to the markers array since we're not technically creating a
      // new text node, just replacing it with one with the required [start..end] substring.  We do
      // need to update the node's offset though.
      marker.offset += start;
      marker.node = dom.insertBefore(document.createTextNode(text.substr(start, end - start + 1)), marker.node);

      // Chars end + 1..length
      if (end !== text.length - 1) {
        if (index >= this.markers.length) {
          throw new Error('Detected invalid index');
        }

        // We're again creating a new text node out of the old text node and thus need to add a new
        // entry to the markers array.
        this.markers.splice(index + 1, 0, {
          offset: marker.offset + end - start + 1,
          node: dom.insertAfter(document.createTextNode(text.substr(end + 1)), marker.node)
        });
      }

      if (_globals2.default.debugging) {
        this.assert();
      }

      // Remove old node.
      old.parentNode.removeChild(old);
      return index;
    }

    /**
     * Return the index of the marker descriptor of a given text offset.
     *
     * Throws an exception if the offset is invalid.
     *
     * Note: employs the binary search algorithm.
     *
     * @param {number} offset - The offset to look up
     * @returns {number} The marker index that contains `offset`
     */

  }, {
    key: 'indexOf',
    value: function indexOf(offset) {
      var markers = this.markers;
      var min = 0;
      var max = markers.length - 1;

      while (min < max) {
        var mid = Math.floor((min + max) / 2);

        if (markers[mid].offset < offset) {
          min = mid + 1;
        } else {
          max = mid;
        }
      }

      if (markers[min].offset <= offset) {
        return min;
      } else if (min === 0) {
        throw new Error('Invalid offset of text content state');
      }

      return min - 1;
    }

    /**
     * Find the index of the marker descriptor of a given text node element
     *
     * @param {Node} element - Reference to the text node to look up
     * @param {number} [start=0] - Start marker index if known for a fact that the text node is to be
     * found **after** a certain offset
     *
     * @returns {number} The marker index of `element` or `-1` if not found.
     */

  }, {
    key: 'find',
    value: function find(element) {
      var start = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;

      if (element.nodeType !== 3) {
        return -1;
      }

      for (var i = start == null ? 0 : start, l = this.markers.length; i < l; ++i // eslint-disable-line indent
      ) {
        if (this.markers[i].node === element) {
          return i;
        }
      }

      return -1;
    }

    /**
     * Return the offset marker descriptor at a given index
     *
     * Throws an exception if the given `index` is out of bounds.
     *
     * @param {number} index - Marker index
     * @returns {Marker} The offset marker descriptor
     */

  }, {
    key: 'at',
    value: function at(index) {
      if (index < 0 || index >= this.markers.length) {
        throw new Error('Invalid marker index');
      }

      return this.markers[index];
    }
  }, {
    key: 'visit_',
    value: function visit_(node, offset) {
      // Only interested in text nodes
      if (node.nodeType === 3) {
        var content = node.nodeValue;
        var length = content.length;

        // Save reference to text node and store global offset in the markers array
        this.markers.push({ node: node, offset: offset });
        this.text += content;
        return offset + length;
      }

      // If current node is not of type text, process its children nodes, if any.
      var ch = node.childNodes;
      if (ch.length > 0) {
        for (var i = 0, l = ch.length; i < l; ++i) {
          offset = this.visit_(ch[i], offset);
        }
      }

      return offset;
    }

    /**
     * Assert textual representation is valid
     *
     * Debug method for asserting that the current textual representation is valid, in particular
     * that the offset markers are all contiguous.
     */

  }, {
    key: 'assert',
    value: function assert() {
      var offset = 0;

      // Ensure offsets are contiguous
      for (var i = 0, l = this.markers.length; i < l; ++i) {
        var marker = this.markers[i];

        if (marker.offset !== offset) {
          _logger2.default.error('invalid offset: %d@ %d:%d ->', i, marker.offset, offset, marker);
          throw new Error('Halting due to invalid offset');
        }

        offset += marker.node.nodeValue.length;
      }
    }
  }]);

  return TextContent;
}();

exports.default = TextContent;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.findLastTextNode = exports.visitDOM = exports.scrollIntoView = exports.isInView = exports.getOffset = exports.insertAfter = exports.insertBefore = exports.createHighlightElement = exports.isHighlightVisible = exports.getAllHighlightElements = exports.getForQuerySet = exports.getHighlightElements = exports.removeClass = exports.addClass = exports.ensureIterable = exports.classNameToSet = undefined;

var _consts = __webpack_require__(3);

function classNameToSet(el) {
  return new Set(el.className.split(' ').map(function (c) {
    return c.trim();
  }).filter(Boolean));
}
// FIXME: this module relies heavily on `document.querySelector` and `document.querySelectorAll`
// methods but suffers from the limitation that it (presently) runs the queries on the wider
// document's DOM.  This means that, should there ever be a use case for multiple HTML Highlighter
// instances running concurrently within the same DOM on separate subtrees, the result of doing so
// would most certainly be undefined and most likely confusing and resulting in loss or corruption
// of (perceived) state.

function ensureIterable(elementOrCollection) {
  return elementOrCollection instanceof NodeList ? elementOrCollection : new Set([elementOrCollection]);
}

function addClass(coll, name) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = ensureIterable(coll)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var el = _step.value;

      var set = classNameToSet(el);
      set.add(name);
      el.className = Array.from(set).join(' ');
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}

function removeClass(coll, name) {
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = ensureIterable(coll)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var el = _step2.value;

      var set = classNameToSet(el);
      set.delete(name);
      el.className = Array.from(set).join(' ');
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }
}

function getHighlightElements(id) {
  return document.querySelectorAll('.' + _consts.Css.highlight + '-id-' + id);
}

function getForQuerySet(qid) {
  return document.querySelectorAll('.' + _consts.Css.highlight + '-' + qid);
}

function getAllHighlightElements() {
  var additionalClass = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  var otherClass = additionalClass ? '.' + additionalClass : '';
  return document.querySelectorAll('.' + _consts.Css.highlight + otherClass);
}

function isHighlightVisible(id) {
  var elements = getHighlightElements(id);
  if (elements.length < 1) {
    return false;
  }

  // A highlight is considered to be visible if its first (and usually only) element possesses
  // height and width greater than 0.
  var bbox = elements[0].getBoundingClientRect();
  return bbox.height > 0 && bbox.width > 0;
}

function createHighlightElement(node, className) {
  var span = document.createElement('span');
  span.className = className;
  node.parentNode.insertBefore(span, node);
  span.appendChild(node);
  return span;
}

function insertBefore(newNode, beforeNode) {
  beforeNode.parentNode.insertBefore(newNode, beforeNode);
  return newNode;
}

function insertAfter(newNode, afterNode) {
  // Automatically adds to the end of the list when `nextSibling` is `null`
  afterNode.parentNode.insertBefore(newNode, afterNode.nextSibling);
  return newNode;
}

// Taken with a few alterations from:
// https://www.kirupa.com/html5/get_element_position_using_javascript.htm
function getOffset(el) {
  var x = 0;
  var y = 0;

  while (el != null) {
    if (el.tagName.toLowerCase() === 'body') {
      // deal with browser quirks with body/window/document and page scroll
      var scrollX = el.scrollLeft || document.documentElement.scrollLeft;
      var scrollY = el.scrollTop || document.documentElement.scrollTop;

      x += el.offsetLeft - scrollX + el.clientLeft;
      y += el.offsetTop - scrollY + el.clientTop;
    } else {
      // for all other non-BODY elements
      x += el.offsetLeft - el.scrollLeft + el.clientLeft;
      y += el.offsetTop - el.scrollTop + el.clientTop;
    }

    el = el.offsetParent;
  }

  return { x: x, y: y };
}

function isInView(el) {
  var bbox = el.getBoundingClientRect();
  return bbox.top >= 0 && bbox.top + bbox.height < window.innerHeight;
}

// Note that flow does not expose a formal Window type, which means we are unable to validate the
// type.
function scrollIntoView(el, container) {
  if (container == null) {
    container = window;
  }

  var containerTop = void 0;
  var containerHeight = void 0;
  if (container === window) {
    containerHeight = window.innerHeight;
    containerTop = window.scrollY;
  } else {
    containerHeight = container.getBoundingClientRect().height;
    containerTop = container.scrollTop;
  }

  var bbox = el.getBoundingClientRect();
  container.scrollTo(window.scrollX, bbox.top + containerTop - (containerHeight - bbox.height) / 2);
}

/**
 * Simple DOM visitor
 *
 * Given a starting node, visits every node while invoking a callback that is expected to produce a
 * boolean value.  Ends when there are no more nodes to visit or the callback returns true.  Note
 * that a truthy value will not terminate visitation; only an explicit `true` value will.
 *
 * @param {Node} node - Node to begin visiting
 * @param {ForEachNodeCallback} callback - Callback to invoke for each node
 *
 * @returns {boolean} Result of last callback call
 */
function visitDOM(node, callback) {
  try {
    if (callback(node) === true) {
      return true;
    }
  } catch (x) {
    console.error('exception raised while executing visitor callback:', x);
  }

  if (node.nodeType === Node.TEXT_NODE) {
    return false;
  }

  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = node.childNodes[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var child = _step3.value;

      if (visitDOM(child, callback)) {
        return true;
      }
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3.return) {
        _iterator3.return();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  return false;
}

/**
 * Find last text node in given DOM sub-tree
 *
 * @param {HTMLElement} container - container element on whose tree to perform search
 * @returns {Node | null} Last text node found or `null` if none
 */
function findLastTextNode(container) {
  var lastTextNode = null;

  visitDOM(container, function (node) {
    if (node.nodeType === Node.TEXT_NODE) {
      lastTextNode = node;
    }

    return false;
  });

  return lastTextNode;
}

// Export "private" functions so they too can be tested.
exports.classNameToSet = classNameToSet;
exports.ensureIterable = ensureIterable;
exports.addClass = addClass;
exports.removeClass = removeClass;
exports.getHighlightElements = getHighlightElements;
exports.getForQuerySet = getForQuerySet;
exports.getAllHighlightElements = getAllHighlightElements;
exports.isHighlightVisible = isHighlightVisible;
exports.createHighlightElement = createHighlightElement;
exports.insertBefore = insertBefore;
exports.insertAfter = insertAfter;
exports.getOffset = getOffset;
exports.isInView = isInView;
exports.scrollIntoView = scrollIntoView;
exports.visitDOM = visitDOM;
exports.findLastTextNode = findLastTextNode;

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _globals = __webpack_require__(5);

var _globals2 = _interopRequireDefault(_globals);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Logging class
 *
 * Emits debug and log console output when the associated HTML Highlighter class's `debug` static
 * attribute is `true`.  Also ensures all messages contain the 'html-highlighter: ' prefix.
 */
var Logger = function () {
  function Logger() {
    _classCallCheck(this, Logger);
  }

  _createClass(Logger, [{
    key: 'debug',
    value: function debug() {
      if (_globals2.default.verbose) {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        this.emit('debug', args);
      }
    }
  }, {
    key: 'log',
    value: function log() {
      if (_globals2.default.verbose) {
        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        this.emit('log', args);
      }
    }
  }, {
    key: 'info',
    value: function info() {
      for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        args[_key3] = arguments[_key3];
      }

      this.emit('info', args);
    }
  }, {
    key: 'warn',
    value: function warn() {
      for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
        args[_key4] = arguments[_key4];
      }

      this.emit('warn', args);
    }
  }, {
    key: 'error',
    value: function error() {
      for (var _len5 = arguments.length, args = Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
        args[_key5] = arguments[_key5];
      }

      this.emit('error', args);
    }
  }, {
    key: 'exception',
    value: function exception() {
      for (var _len6 = arguments.length, args = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
        args[_key6] = arguments[_key6];
      }

      args = this.prepend(args, 'exception occurred', 'unknown exception occurred');
      this.emit('error', args);
    }
  }, {
    key: 'prepend',
    value: function prepend(args, str, strIfEmpty) {
      if (args.length === 0) {
        return [strIfEmpty || str];
      }

      var first = args[0];
      if (typeof first === 'string') {
        args[0] = str + ': ' + first;
      }

      return args;
    }
  }, {
    key: 'emit',
    value: function emit(type, args) {
      var fn = console[type];
      if (fn == null) {
        console.error('logger: console function \'' + type + '\' undefined or invalid');
      } else {
        fn.apply(console, this.prepend(args, 'html-highlighter'));
      }
    }
  }]);

  return Logger;
}();

exports.default = new Logger();

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var Css = exports.Css = {
  highlight: 'hh-highlight',
  enabled: 'hh-enabled',
  disabled: 'hh-disabled'
};

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dom = __webpack_require__(1);

var dom = _interopRequireWildcard(_dom);

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _textnodevisitor = __webpack_require__(23);

var _textnodevisitor2 = _interopRequireDefault(_textnodevisitor);

var _textnodexpath = __webpack_require__(15);

var _textnodexpath2 = _interopRequireDefault(_textnodexpath);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Holds a representation of a range between two text nodes
 *
 * @param {TextContent} content - text representation instance
 * @param {Object} start - descriptor of start of range
 * @param {Object} end - descriptor of end of range
 */
var TextRange = function () {
  _createClass(TextRange, null, [{
    key: 'descriptorAbs',


    /**
     * Create a range descriptor from a global offset.
     *
     * @param {Marker} marker - Text offset marker object
     * @param {number} offset - Global offset
     *
     * @returns {RangeDescriptor} Range descriptor */
    value: function descriptorAbs(marker, offset) {
      return { marker: marker, offset: offset - marker.offset };
    }

    /**
     * Create a range descriptor from an offset relative to the start of the text node
     *
     * @param {Marker} marker - Text offset marker object
     * @param {number} offset - Relative offset from start of text node
     *
     * @returns {RangeDescriptor} Range descriptor
     */

  }, {
    key: 'descriptorRel',
    value: function descriptorRel(marker, offset) {
      return { marker: marker, offset: offset };
    }
  }]);

  function TextRange(content, start, end) {
    _classCallCheck(this, TextRange);

    this.content = content;

    // Sanity check:
    if (start.marker.offset + start.offset > end.marker.offset + end.offset) {
      throw new Error('Invalid range: start > end');
    }

    this.start = start;
    this.end = end;
  }

  /**
   * Highlight a range
   *
   * Highlights a given range by wrapping one or more text nodes with a `span` tag and applying a
   * particular CSS class.
   *
   * @param {string} className - The CSS class name to apply
   */


  _createClass(TextRange, [{
    key: 'surround',
    value: function surround(className) {
      var _this = this;

      // Optimised case: highlighting does not span multiple nodes
      if (this.start.marker.node === this.end.marker.node) {
        this.surround_(this.start, this.start.offset, this.end.offset, className);
        this.start.offset = 0;
        return;
      }

      // Highlighting spans 2 or more nodes, which means we need to build a representation of all the
      // text nodes contained in the start to end range, but excluding the start and end nodes
      var visitor = new _textnodevisitor2.default(this.start.marker.node, this.content.root);
      var end = this.end.marker.node;
      var coll = [];

      // TODO: we assume `visitor.next()' will never return null because `end´ is within bounds
      while (visitor.next() !== end) {
        coll.push(visitor.current);
      }

      // Apply highlighting to start and end nodes, and to any nodes in between, if applicable.
      // Highlighting for the start and end nodes may require text node truncation but not for the
      // nodes in between.
      this.surround_(this.start, this.start.offset, null, className);
      coll.forEach(function (n) {
        return _this.surroundWhole_(n, className);
      });
      this.surround_(this.end, 0, this.end.offset, className);
      this.start.offset = 0;
    }

    /**
     * Compute the XPath representation of the active range
     *
     * @returns {RangeXpathDescriptor} XPath representation of active range
     */

  }, {
    key: 'computeXpath',
    value: function computeXpath() {
      var start = this.start.marker.node;
      var end = this.end.marker.node;
      var computor = new _textnodexpath2.default(this.content.root);
      return {
        start: {
          xpath: computor.xpathOf(start),
          offset: this.start.offset + computor.offset(start)
        },
        end: {
          xpath: computor.xpathOf(end),
          offset: this.end.offset + computor.offset(end) + 1
        }
      };
    }

    /**
     * Compute the length of the active range
     *
     * @returns {number} Number of characters
     */

  }, {
    key: 'length',
    value: function length() {
      // Optimised case: range does not span multiple nodes
      if (this.start.marker.node === this.end.marker.node) {
        return this.end.offset - this.start.offset + 1;
      }

      // Range spans 2 or more nodes
      var visitor = new _textnodevisitor2.default(this.start.marker.node, this.content.root);
      var end = this.end.marker.node;
      var length = this.start.marker.node.nodeValue.length - this.start.offset + this.end.offset + 1;

      // Add (whole) lengths of text nodes in between
      while (visitor.next() !== end) {
        length += visitor.current.nodeValue.length;
      }

      return length;
    }

    // Private interface
    // -----------------
    /**
     * Truncate text node and apply highlighting
     *
     * Truncates text node into 2 or 3 text nodes and apply highlighting to relevant node, which is
     * always the node referenced by `descr.marker.node`.
     *
     * @param {Object} descr - Start or end `Range` descriptor
     * @param {number} start - Start offset
     * @param {number | null} end - End offset
     * @param {string} className - CSS class name to apply
     */

  }, {
    key: 'surround_',
    value: function surround_(descr, start, end, className) {
      this.content.truncate(descr.marker, start, end == null ? descr.marker.node.nodeValue.length - 1 : end);

      dom.createHighlightElement(descr.marker.node, className);
    }

    /**
     * Apply highlighting fully to a text node
     *
     * No text node truncation occurs.
     *
     * @param {Node} node - Text node to apply highlighting to
     * @param {string} className - CSS class name to apply
     * */

  }, {
    key: 'surroundWhole_',
    value: function surroundWhole_(node, className) {
      dom.createHighlightElement(node, className);
    }
  }]);

  return TextRange;
}();

exports.default = TextRange;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
var globals = {
  verbose: false,
  debugging: false
};

function setVerbose(active) {
  globals.verbose = active;
}

function getVerbose() {
  return globals.verbose;
}

function setDebugging(active) {
  globals.debugging = active;
}

function getDebugging() {
  return globals.debugging;
}

exports.default = globals;
exports.setVerbose = setVerbose;
exports.getVerbose = getVerbose;
exports.setDebugging = setDebugging;
exports.getDebugging = getDebugging;

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
/* eslint-disable camelcase */

/* eslint-enable camelcase */


var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _util = __webpack_require__(7);

var util = _interopRequireWildcard(_util);

var _textrange = __webpack_require__(4);

var _textrange2 = _interopRequireDefault(_textrange);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Abstract base class of all finder classes
 *
 * @abstract
 * @param {TextContent} content - reference to `TextContent` holding a text representation of the
 * document.
 * @param {*} subject - subject to find; can be of any type
 */
var Finder = function () {
  function Finder(content) {
    _classCallCheck(this, Finder);

    this.content = content;
    this.results = [];
    this.current = 0;
  }

  /**
   * @abstract
   * Return next available match
   *
   * If no more matches available, returns `null`.
   *
   * @returns {TextRange | null} Returns a `TextRange` if a match is available, or `null` if no
   * more matches are available.
   */
  // $FlowFixMe: below signature is needed in specialized classes


  _createClass(Finder, [{
    key: 'next',
    value: function next() {
      util.abstract();
    }

    // Protected interface
    // -------------------
    /**
     * Return a `TextRange` descriptor for a given offset
     * @access private
     *
     * @param {number} offset - Text offset
     * @returns {RangeDescriptor} Range descriptor
     */

  }, {
    key: 'getAt_',
    value: function getAt_(offset) {
      var index = this.content.indexOf(offset);
      if (index === -1) {
        throw new Error('Failed to retrieve marker for offset: ' + offset);
      }

      return _textrange2.default.descriptorAbs(this.content.at(index), offset);
    }
  }]);

  return Finder;
}();

exports.default = Finder;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});


function abstract() {
  throw new Error('Abstract method not implemented');
}

function createPromiseCapabilities() {
  var resolve = void 0,
      fail = void 0;
  var instance = new Promise(function (pr, pf) {
    resolve = pr;
    fail = pf;
  });

  // $FlowFixMe: `resolve` and `fail` are defined at this point
  return {
    instance: instance,
    resolve: resolve,
    fail: fail
  };
}

exports.abstract = abstract;
exports.createPromiseCapabilities = createPromiseCapabilities;

/***/ }),
/* 8 */
/***/ (function(module, exports) {

// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

function EventEmitter() {
  this._events = this._events || {};
  this._maxListeners = this._maxListeners || undefined;
}
module.exports = EventEmitter;

// Backwards-compat with node 0.10.x
EventEmitter.EventEmitter = EventEmitter;

EventEmitter.prototype._events = undefined;
EventEmitter.prototype._maxListeners = undefined;

// By default EventEmitters will print a warning if more than 10 listeners are
// added to it. This is a useful default which helps finding memory leaks.
EventEmitter.defaultMaxListeners = 10;

// Obviously not all Emitters should be limited to 10. This function allows
// that to be increased. Set to zero for unlimited.
EventEmitter.prototype.setMaxListeners = function(n) {
  if (!isNumber(n) || n < 0 || isNaN(n))
    throw TypeError('n must be a positive number');
  this._maxListeners = n;
  return this;
};

EventEmitter.prototype.emit = function(type) {
  var er, handler, len, args, i, listeners;

  if (!this._events)
    this._events = {};

  // If there is no 'error' event listener then throw.
  if (type === 'error') {
    if (!this._events.error ||
        (isObject(this._events.error) && !this._events.error.length)) {
      er = arguments[1];
      if (er instanceof Error) {
        throw er; // Unhandled 'error' event
      } else {
        // At least give some kind of context to the user
        var err = new Error('Uncaught, unspecified "error" event. (' + er + ')');
        err.context = er;
        throw err;
      }
    }
  }

  handler = this._events[type];

  if (isUndefined(handler))
    return false;

  if (isFunction(handler)) {
    switch (arguments.length) {
      // fast cases
      case 1:
        handler.call(this);
        break;
      case 2:
        handler.call(this, arguments[1]);
        break;
      case 3:
        handler.call(this, arguments[1], arguments[2]);
        break;
      // slower
      default:
        args = Array.prototype.slice.call(arguments, 1);
        handler.apply(this, args);
    }
  } else if (isObject(handler)) {
    args = Array.prototype.slice.call(arguments, 1);
    listeners = handler.slice();
    len = listeners.length;
    for (i = 0; i < len; i++)
      listeners[i].apply(this, args);
  }

  return true;
};

EventEmitter.prototype.addListener = function(type, listener) {
  var m;

  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events)
    this._events = {};

  // To avoid recursion in the case that type === "newListener"! Before
  // adding it to the listeners, first emit "newListener".
  if (this._events.newListener)
    this.emit('newListener', type,
              isFunction(listener.listener) ?
              listener.listener : listener);

  if (!this._events[type])
    // Optimize the case of one listener. Don't need the extra array object.
    this._events[type] = listener;
  else if (isObject(this._events[type]))
    // If we've already got an array, just append.
    this._events[type].push(listener);
  else
    // Adding the second element, need to change to array.
    this._events[type] = [this._events[type], listener];

  // Check for listener leak
  if (isObject(this._events[type]) && !this._events[type].warned) {
    if (!isUndefined(this._maxListeners)) {
      m = this._maxListeners;
    } else {
      m = EventEmitter.defaultMaxListeners;
    }

    if (m && m > 0 && this._events[type].length > m) {
      this._events[type].warned = true;
      console.error('(node) warning: possible EventEmitter memory ' +
                    'leak detected. %d listeners added. ' +
                    'Use emitter.setMaxListeners() to increase limit.',
                    this._events[type].length);
      if (typeof console.trace === 'function') {
        // not supported in IE 10
        console.trace();
      }
    }
  }

  return this;
};

EventEmitter.prototype.on = EventEmitter.prototype.addListener;

EventEmitter.prototype.once = function(type, listener) {
  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  var fired = false;

  function g() {
    this.removeListener(type, g);

    if (!fired) {
      fired = true;
      listener.apply(this, arguments);
    }
  }

  g.listener = listener;
  this.on(type, g);

  return this;
};

// emits a 'removeListener' event iff the listener was removed
EventEmitter.prototype.removeListener = function(type, listener) {
  var list, position, length, i;

  if (!isFunction(listener))
    throw TypeError('listener must be a function');

  if (!this._events || !this._events[type])
    return this;

  list = this._events[type];
  length = list.length;
  position = -1;

  if (list === listener ||
      (isFunction(list.listener) && list.listener === listener)) {
    delete this._events[type];
    if (this._events.removeListener)
      this.emit('removeListener', type, listener);

  } else if (isObject(list)) {
    for (i = length; i-- > 0;) {
      if (list[i] === listener ||
          (list[i].listener && list[i].listener === listener)) {
        position = i;
        break;
      }
    }

    if (position < 0)
      return this;

    if (list.length === 1) {
      list.length = 0;
      delete this._events[type];
    } else {
      list.splice(position, 1);
    }

    if (this._events.removeListener)
      this.emit('removeListener', type, listener);
  }

  return this;
};

EventEmitter.prototype.removeAllListeners = function(type) {
  var key, listeners;

  if (!this._events)
    return this;

  // not listening for removeListener, no need to emit
  if (!this._events.removeListener) {
    if (arguments.length === 0)
      this._events = {};
    else if (this._events[type])
      delete this._events[type];
    return this;
  }

  // emit removeListener for all listeners on all events
  if (arguments.length === 0) {
    for (key in this._events) {
      if (key === 'removeListener') continue;
      this.removeAllListeners(key);
    }
    this.removeAllListeners('removeListener');
    this._events = {};
    return this;
  }

  listeners = this._events[type];

  if (isFunction(listeners)) {
    this.removeListener(type, listeners);
  } else if (listeners) {
    // LIFO order
    while (listeners.length)
      this.removeListener(type, listeners[listeners.length - 1]);
  }
  delete this._events[type];

  return this;
};

EventEmitter.prototype.listeners = function(type) {
  var ret;
  if (!this._events || !this._events[type])
    ret = [];
  else if (isFunction(this._events[type]))
    ret = [this._events[type]];
  else
    ret = this._events[type].slice();
  return ret;
};

EventEmitter.prototype.listenerCount = function(type) {
  if (this._events) {
    var evlistener = this._events[type];

    if (isFunction(evlistener))
      return 1;
    else if (evlistener)
      return evlistener.length;
  }
  return 0;
};

EventEmitter.listenerCount = function(emitter, type) {
  return emitter.listenerCount(type);
};

function isFunction(arg) {
  return typeof arg === 'function';
}

function isNumber(arg) {
  return typeof arg === 'number';
}

function isObject(arg) {
  return typeof arg === 'object' && arg !== null;
}

function isUndefined(arg) {
  return arg === void 0;
}


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

/* WEBPACK VAR INJECTION */(function(module) {/*!
 * @name JavaScript/NodeJS Merge v1.2.0
 * @author yeikos
 * @repository https://github.com/yeikos/js.merge

 * Copyright 2014 yeikos - MIT license
 * https://raw.github.com/yeikos/js.merge/master/LICENSE
 */

;(function(isNode) {

	/**
	 * Merge one or more objects 
	 * @param bool? clone
	 * @param mixed,... arguments
	 * @return object
	 */

	var Public = function(clone) {

		return merge(clone === true, false, arguments);

	}, publicName = 'merge';

	/**
	 * Merge two or more objects recursively 
	 * @param bool? clone
	 * @param mixed,... arguments
	 * @return object
	 */

	Public.recursive = function(clone) {

		return merge(clone === true, true, arguments);

	};

	/**
	 * Clone the input removing any reference
	 * @param mixed input
	 * @return mixed
	 */

	Public.clone = function(input) {

		var output = input,
			type = typeOf(input),
			index, size;

		if (type === 'array') {

			output = [];
			size = input.length;

			for (index=0;index<size;++index)

				output[index] = Public.clone(input[index]);

		} else if (type === 'object') {

			output = {};

			for (index in input)

				output[index] = Public.clone(input[index]);

		}

		return output;

	};

	/**
	 * Merge two objects recursively
	 * @param mixed input
	 * @param mixed extend
	 * @return mixed
	 */

	function merge_recursive(base, extend) {

		if (typeOf(base) !== 'object')

			return extend;

		for (var key in extend) {

			if (typeOf(base[key]) === 'object' && typeOf(extend[key]) === 'object') {

				base[key] = merge_recursive(base[key], extend[key]);

			} else {

				base[key] = extend[key];

			}

		}

		return base;

	}

	/**
	 * Merge two or more objects
	 * @param bool clone
	 * @param bool recursive
	 * @param array argv
	 * @return object
	 */

	function merge(clone, recursive, argv) {

		var result = argv[0],
			size = argv.length;

		if (clone || typeOf(result) !== 'object')

			result = {};

		for (var index=0;index<size;++index) {

			var item = argv[index],

				type = typeOf(item);

			if (type !== 'object') continue;

			for (var key in item) {

				var sitem = clone ? Public.clone(item[key]) : item[key];

				if (recursive) {

					result[key] = merge_recursive(result[key], sitem);

				} else {

					result[key] = sitem;

				}

			}

		}

		return result;

	}

	/**
	 * Get type of variable
	 * @param mixed input
	 * @return string
	 *
	 * @see http://jsperf.com/typeofvar
	 */

	function typeOf(input) {

		return ({}).toString.call(input).slice(8, -1).toLowerCase();

	}

	if (isNode) {

		module.exports = Public;

	} else {

		window[publicName] = Public;

	}

})(typeof module === 'object' && module && typeof module.exports === 'object' && module.exports);
/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(24)(module)))

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = __webpack_require__(8);

var _events2 = _interopRequireDefault(_events);

var _merge = __webpack_require__(9);

var _merge2 = _interopRequireDefault(_merge);

var _globals = __webpack_require__(5);

var _globals2 = _interopRequireDefault(_globals);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

var _consts = __webpack_require__(3);

var _dom = __webpack_require__(1);

var dom = _interopRequireWildcard(_dom);

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _highlightmarkers = __webpack_require__(14);

var _highlightmarkers2 = _interopRequireDefault(_highlightmarkers);

var _renderer = __webpack_require__(21);

var _renderer2 = _interopRequireDefault(_renderer);

var _cursor = __webpack_require__(17);

var _cursor2 = _interopRequireDefault(_cursor);

var _util = __webpack_require__(7);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
/* eslint-disable camelcase */


/**
 * Main class of the HTML Highlighter module, which exposes an API enabling
 * clients to control all the features supported related to highlighting and
 * text selection.
 *
 * Emits the following events:
 *
 *  - refresh: text content refreshed
 *  - add: query set added
 *  - append: queries added to query set
 *  - remove: query set removed
 *  - enable: query set enabled
 *  - disable: query set disabled
 *  - clear: all query sets removed and cursor cleared
 */
var HtmlHighlighter = function (_EventEmitter) {
  _inherits(HtmlHighlighter, _EventEmitter);

  function HtmlHighlighter(options) {
    _classCallCheck(this, HtmlHighlighter);

    // Merge default options
    var _this = _possibleConstructorReturn(this, (HtmlHighlighter.__proto__ || Object.getPrototypeOf(HtmlHighlighter)).call(this));

    _this.onHighlightCreated = function (querySet, hit, id, state) {
      // $FlowFixMe: `hit` cannot be `null` here as per condition in `while` above
      _this.markers.add(querySet, id, hit);
      if (state != null) {
        _this.state.set(id, state);
      }
      _this.emit('highlight', id, state);
    };

    _this.onHighlightRemoved = function (id) {
      _this.state.delete(id);
      _this.emit('unhighlight', id);
    };

    _this.options = (0, _merge2.default)({}, HtmlHighlighter.defaults, options);

    _this.queries = new Map();
    _this.markers = new _highlightmarkers2.default();
    _this.state = new Map();

    // TODO: rename attribute to something else that makes it clear it refers to the next highlight
    // id.
    _this.lastId = 0;

    // TODO: refactor the following map.  In particular, the `highlight` attribute BADLY needs to
    // become a class attribute of its own since it refers to the NEXT query set id.
    _this.stats = {
      queries: 0,
      total: 0,
      highlight: 0
    };

    var container = options.container;

    if (container == null) {
      _this.options.container = window.document.body;
    } else if (container instanceof HTMLElement) {
      _this.options.container = container;
    }

    _this.renderer = new _renderer2.default(_this.options);
    _this.renderer.on('highlight', _this.onHighlightCreated);
    _this.renderer.on('unhighlight', _this.onHighlightRemoved);

    _this.cursor = new _cursor2.default(_this.markers);

    // Start by refreshing the internal document's text representation, which initialises
    // `this.content`.
    _this.refresh();
    _logger2.default.log('instantiated');
    return _this;
  }

  /**
   * Refreshes the internal representation of the text.
   *
   * Should only be invoked when the HTML structure mutates.
   */


  // Default options.  Note that we cannot declare this map as `Options` since not all attributes
  // are defined (e.g. `container`).


  _createClass(HtmlHighlighter, [{
    key: 'refresh',
    value: function refresh() {
      this.content = new _textcontent2.default(this.options.container);
      if (_globals2.default.debugging) {
        this.assert();
      }
      this.renderer.setContent(this.content);
      this.emit('refresh');
    }

    /**
     * Create a query set by the name and containing one or more queries
     *
     * If the query set already exists, its contents and highlights are firs destroyed and new one
     * created.  Optionally, it is possible to specify a number of highlights to reserve for the
     * query set.
     *
     * Note that, at this point in time, only string queries and XPath representations are supported.
     *
     * @param {string} name - Name of the query set
     * @param {Array<any>} queries - Array containing individual queries to highlight
     * @param {boolean} enabled - If explicitly `false`, query set is disabled; otherwise enabled
     * @param {number} [reserve] - Number of highlights to reserve for query set
     *
     * @returns {Promise<number>} Promise that resolves with number of highlights created
     */

  }, {
    key: 'add',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name, queries) {
        var _this2 = this;

        var enabled = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var reserve = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
        var querySet, renderer, promise;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                enabled = enabled === true;
                if (typeof reserve !== 'number' || reserve < 1) {
                  reserve = null;
                }

                querySet = {
                  name: name,
                  enabled: enabled,
                  queryId: -1,
                  highlightId: -1,
                  length: 0,
                  reserve: null
                };

                // Enqueue query set removal rendering operation by default to ensure that we succeed in adding
                // this query.  This measure results in no rendering if the query set does not exist.

                this.remove_(name, true);

                renderer = this.renderer.add(name, queries);

                renderer.on('init', function () {
                  // Don't process query set if it turns out to already exist
                  if (_this2.queries.has(name)) {
                    renderer.abort();
                    return;
                  }

                  _logger2.default.log('adding queries to: ' + querySet.name);
                  _this2.queries.set(name, querySet);
                  querySet.queryId = _this2.stats.highlight;
                  querySet.highlightId = _this2.lastId;
                  renderer.init(querySet);
                });

                promise = (0, _util.createPromiseCapabilities)();

                renderer.on('done', function (count) {
                  querySet.length += count;
                  if (enabled) {
                    _this2.stats.total += count;
                  }

                  if (reserve != null) {
                    if (reserve > count) {
                      _this2.lastId = reserve;
                      querySet.reserve = reserve;
                    } else {
                      _logger2.default.error('invalid or insufficient reserve specified');
                      querySet.reserve = count;
                    }
                  } else {
                    _this2.lastId += count;
                  }

                  // Update global statistics
                  ++_this2.stats.queries;

                  // Ensure CSS highlight class rolls over on overflow
                  ++_this2.stats.highlight;
                  if (_this2.stats.highlight >= _this2.options.maxHighlight) {
                    _this2.stats.highlight = 0;
                  }

                  _this2.cursor.clear();
                  _this2.emit('add', name, querySet, queries);

                  if (_globals2.default.debugging) {
                    _this2.assert();
                  }

                  promise.resolve(count);
                });

                renderer.on('abort', function () {
                  return promise.resolve();
                });

                this.renderer.next();
                return _context.abrupt('return', promise.instance);

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function add(_x, _x2) {
        return _ref.apply(this, arguments);
      }

      return add;
    }()

    /**
     * Append one or more queries to an existing query set
     *
     * If the query set doesn't yet exist, an exception is thrown. In addition, the query set
     * **must** have enough reserved space available to contain the new queries.  All queries not
     * fitting in the container are suppressed.
     *
     * @param {string} name - Name of the query set
     * @param {QuerySubject} queries - Array containing individual queries to highlight
     *
     * @returns {Promise<number>} Promise that resolves with number of highlights created
     */

  }, {
    key: 'append',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(name, queries) {
        var _this3 = this;

        var querySet, renderer, promise;
        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                querySet = void 0;
                renderer = this.renderer.add(name, queries);
                promise = (0, _util.createPromiseCapabilities)();

                renderer.on('init', function () {
                  querySet = _this3.queries.get(name);
                  if (querySet == null) {
                    renderer.abort();
                    return;
                  }

                  _logger2.default.log('appending queries to: ' + querySet.name);
                  renderer.init(querySet);
                });

                renderer.on('done', function (count) {
                  // Should never happen
                  if (querySet == null) {
                    return;
                  }

                  querySet.length += count;
                  if (querySet.enabled) {
                    _this3.stats.total += count;
                  }

                  _this3.cursor.clear();
                  _this3.emit('append', name, querySet, queries);

                  if (_globals2.default.debugging) {
                    _this3.assert();
                  }

                  promise.resolve(count);
                });

                renderer.on('abort', function () {
                  return promise.resolve();
                });

                this.renderer.next();
                return _context2.abrupt('return', promise.instance);

              case 8:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function append(_x5, _x6) {
        return _ref2.apply(this, arguments);
      }

      return append;
    }()

    /**
     * Remove a query set by name
     *
     * An exception is thrown if the query set does not exist.
     *
     * @param {string} name - Name of the query set to remove.
     */

  }, {
    key: 'remove',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(name) {
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                _context3.next = 2;
                return this.remove_(name, false);

              case 2:
                this.cursor.clear();
                this.emit('remove', name);

              case 4:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function remove(_x7) {
        return _ref3.apply(this, arguments);
      }

      return remove;
    }()

    /**
     * Enable a query set
     *
     * An exception is thrown if the query set does not exist.  If the query set is currently already
     * enabled, nothing is done.
     *
     * @param {string} name - Name of the query set to enable.
     */

  }, {
    key: 'enable',
    value: function enable(name) {
      var q = this.get_(name);
      if (q.enabled) {
        return;
      }

      dom.removeClass(dom.getForQuerySet(q.queryId), _consts.Css.disabled);

      q.enabled = true;
      this.stats.total += q.length;
      this.cursor.clear();
      this.emit('enable', name);
    }

    /**
     * Disable a query set
     *
     * An exception is thrown if the query set does not exist.  If the query set is currently already
     * disabled, nothing is done.
     *
     * @param {string} name - Name of the query set to disable.
     */

  }, {
    key: 'disable',
    value: function disable(name) {
      var q = this.get_(name);
      if (!q.enabled) {
        return;
      }

      dom.addClass(dom.getForQuerySet(q.queryId), _consts.Css.disabled);

      q.enabled = false;
      this.stats.total -= q.length;
      this.cursor.clear();
      this.emit('disable', name);
    }

    /**
     * Remove all query sets
     *
     * Optionally, the last query set id can be reset.
     *
     * @param {boolean} reset - Last query set id is reset, if `true`.
     */

  }, {
    key: 'clear',
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(reset) {
        var promises, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step$value, name;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                promises = [];
                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context4.prev = 4;

                for (_iterator = this.queries[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                  _step$value = _slicedToArray(_step.value, 1), name = _step$value[0];

                  promises.push(this.remove_(name, false));
                }

                _context4.next = 12;
                break;

              case 8:
                _context4.prev = 8;
                _context4.t0 = _context4['catch'](4);
                _didIteratorError = true;
                _iteratorError = _context4.t0;

              case 12:
                _context4.prev = 12;
                _context4.prev = 13;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 15:
                _context4.prev = 15;

                if (!_didIteratorError) {
                  _context4.next = 18;
                  break;
                }

                throw _iteratorError;

              case 18:
                return _context4.finish(15);

              case 19:
                return _context4.finish(12);

              case 20:
                _context4.next = 22;
                return Promise.all(promises);

              case 22:

                if (reset) {
                  this.lastId = 0;
                  this.stats.highlight = 0;
                }

                this.cursor.clear();
                this.emit('clear');

                if (_globals2.default.debugging) {
                  this.assert();
                }

              case 26:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[4, 8, 12, 20], [13,, 15, 19]]);
      }));

      function clear(_x8) {
        return _ref4.apply(this, arguments);
      }

      return clear;
    }()

    /**
     * Return boolean value indicating whether a query exists
     *
     * @param {string} name - the name of query set
     * @returns {boolean} `true` if query exists
     */

  }, {
    key: 'has',
    value: function has(name) {
      return this.queries.has(name);
    }

    /**
     * Return state associated with highlight
     *
     * @param {number} highlightId - Highlight ID
     * @returns {any} State associated with highlight; `undefined` or `null` otherwise
     */

  }, {
    key: 'getState',
    value: function getState(highlightId) {
      return this.state.get(highlightId);
    }

    /**
     * Return boolean indicative of whether one or more query sets are currently contained
     *
     * @returns {boolean} `false` if no query sets currently
     * contained; `true` otherwise. */

  }, {
    key: 'empty',
    value: function empty() {
      return this.queries.size === 0;
    }

    /**
     * Return the last highlight id of a query set
     *
     * @param {string} name - the name of the query set.
     * @returns {number} the last highlight id or `-1` if query set empty.
     * */

  }, {
    key: 'lastIdOf',
    value: function lastIdOf(name) {
      var q = this.get_(name);
      var l = q.length;
      return l > 0 ? q.highlightId + l - 1 : -1;
    }

    /**
     * @event
     * Handle highlight creation
     *
     * Contains state associated with highlight and exposes event for clients.
     *
     * @param {QuerySet} querySet - associated highlight query set
     * @param {TextRange} hit - highlight text range
     * @param {number} id - highlight ID
     * @param {any} state - associated highlight state
     */


    /**
     * @event
     * Handle highlight removal
     *
     * Removes state associated with highlight and exposes event for clients.
     *
     * @param {number} id - highlight ID
     */

  }, {
    key: 'remove_',


    // Private interface
    // -----------------
    /**
     * Remove a query set by name
     *
     * Throws an exception if the query set does not exist.
     * @access private
     *
     * @param {string} name - The name of the query set to remove.
     * @param {boolean} enqueue - When `true` causes rendering to be enqueued and not started.
     *
     * @returns {Promise<void>} Promise that resolves upon completion
     */
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(name, enqueue) {
        var _this4 = this;

        var querySet, promise, renderer;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                querySet = void 0;
                promise = (0, _util.createPromiseCapabilities)();
                renderer = this.renderer.remove();

                renderer.on('init', function () {
                  querySet = _this4.queries.get(name);
                  if (querySet == null) {
                    renderer.abort();
                    return;
                  }

                  _logger2.default.log('remove query set: ' + querySet.name);
                  renderer.init(querySet);
                });

                renderer.on('done', function () {
                  // Should never happen
                  if (querySet == null) {
                    return;
                  }

                  _this4.markers.removeAll(querySet);
                  _this4.queries.delete(name);

                  --_this4.stats.queries;
                  _this4.stats.total -= querySet.length;

                  // TODO: Unfortunately, using the built-in `normalize` `HTMLElement` method to normalise text
                  // nodes means we have to refresh the offsets of the text nodes, which may not be desirable.
                  // There must be a better way.
                  if (_this4.options.normalise) {
                    _this4.options.container.normalize();
                    _this4.refresh();
                  }

                  if (_globals2.default.debugging) {
                    _this4.assert();
                  }

                  promise.resolve();
                });

                renderer.on('abort', function () {
                  return promise.resolve();
                });

                if (!enqueue) {
                  this.renderer.next();
                }
                return _context5.abrupt('return', promise.instance);

              case 8:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function remove_(_x9, _x10) {
        return _ref5.apply(this, arguments);
      }

      return remove_;
    }()

    /**
     * Safely retrieve a query set's descriptor
     *
     * Throws an exception if the query set does not exist.
     *
     * @param {string} name - The name of the query set to retrieve.
     * @returns {QuerySet} Query set descriptor
     */

  }, {
    key: 'get_',
    value: function get_(name) {
      var q = this.queries.get(name);
      if (q == null) {
        throw new Error('Query set non-existent: ' + name);
      }
      return q;
    }

    /**
     * Perform assorted debugging assertions
     */

  }, {
    key: 'assert',
    value: function assert() {
      this.content.assert();

      var size = 0;
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = this.queries[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var _step2$value = _slicedToArray(_step2.value, 2),
              query = _step2$value[1];

          size += query.length;
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }

      this.markers.assert(size);

      if (this.lastId === 0 || this.stats.highlight === 0) {
        if (this.lastId !== this.stats.highlight) {
          throw new Error('IDs mismatch when empty');
        } else if (this.queries.size !== 0) {
          throw new Error('Queries map not empty');
        } else if (this.state.size !== 0) {
          throw new Error('Highlight state map not empty');
        }
      } else if (this.state.size > size) {
        throw new Error('Unexpected highlight state');
      }
    }
  }]);

  return HtmlHighlighter;
}(_events2.default);

HtmlHighlighter.defaults = {
  // Sometimes it is useful for the client to determine how to bring an element into view via
  // scrolling. If `scrollTo` is set, then it is called as a function with a `Node` to scroll
  // to.
  scrollTo: null,
  maxHighlight: 1,
  useQueryAsClass: false,
  normalise: true,
  rendering: {
    async: false,
    interval: 250 // In effect only if `async` is `true`; value in ms.
  }
};
exports.default = HtmlHighlighter;

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _consts = __webpack_require__(3);

var _textrange = __webpack_require__(4);

var _textrange2 = _interopRequireDefault(_textrange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Convenience class for applying highlights on arbitrary `TextRange` instances
 *
 * A `classes` attribute is cached at construction time with the CSS classes that will apply to all
 * created highlight instances, namely the:
 *
 *   - base highlight class (e.g. `hh-highlight`)
 *   - query ID class (e.g. `hh-highlight-1`)
 *
 * Then, each time a given range is highlighted, the CSS classes applied to the created highlight
 * element(s) are whatever was crafted at construction time plus a CSS class that uniquely
 * identifies the highlight, which takes the following form: `hh-highlight-id-${highlightID}`.
 * Finally, the highlight ID is returned but also incremented so the next generated highlight is
 * guaranteed to be unique.
 */
var RangeHighlighter = function () {

  /**
   * Class constructor
   *
   * @param {number} queryId - The ID of the query set highlights belong to
   * @param {number} highlightId - The first available highlight ID to apply
   * @param {bool} enabled - If explicitly `false`, highlights are created but not shown
   * @param {string | null} cssClass - Additional CSS class to use
   */
  function RangeHighlighter(queryId, highlightId, enabled, cssClass) {
    _classCallCheck(this, RangeHighlighter);

    var classes = [_consts.Css.highlight, _consts.Css.highlight + '-' + queryId];

    if (cssClass != null) {
      classes.push(cssClass);
    }

    if (enabled === false) {
      classes.push(_consts.Css.disabled);
    }

    this.classes = classes.join(' ');
    this.id = highlightId;
  }

  /**
   * Highlight a `TextRange` instance
   *
   * Causes the current highlight `id` attribute to be incremented.
   *
   * @param {TextRange} range - TextRange instance to apply highlighting to
   * @returns {number} Unique highlight id
   */


  _createClass(RangeHighlighter, [{
    key: 'do',
    value: function _do(range) {
      range.surround(this.classes + ' ' + _consts.Css.highlight + '-id-' + this.id);
      return this.id++;
    }
  }]);

  return RangeHighlighter;
}();

exports.default = RangeHighlighter;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _merge = __webpack_require__(9);

var _merge2 = _interopRequireDefault(_merge);

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _finder = __webpack_require__(6);

var _finder2 = _interopRequireDefault(_finder);

var _textrange = __webpack_require__(4);

var _textrange2 = _interopRequireDefault(_textrange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* FIXME: create a class for matching of regular expression subjects. */
/**
 * Class responsible for finding text in a `TextContent` instance
 */
var TextFinder = function (_Finder) {
  _inherits(TextFinder, _Finder);

  _createClass(TextFinder, null, [{
    key: 'isSubject',

    /**
     * Determine if given subject is of type accepted by the `TextFinder` class
     *
     * This method determines if a given subject can be used to instantiate a `TextFinder` class.
     *
     * @param {any} subject - Subject to determine
     * @returns {boolean} `true` if subject can be used to instantiate a `TextFinder` class
     */
    value: function isSubject(subject) {
      return typeof subject === 'string' || subject instanceof RegExp;
    }

    /**
     * Class constructor
     *
     * @param {TextContent} content - Reference to `TextContent` instance
     * @param {TextFinderSubject} subject - Subject string to match
     */

  }]);

  function TextFinder(content, subject) {
    _classCallCheck(this, TextFinder);

    // Build an array containing all hits of `subject´
    var _this = _possibleConstructorReturn(this, (TextFinder.__proto__ || Object.getPrototypeOf(TextFinder)).call(this, content));
    // Construct base class


    var match = void 0;
    var re = subject instanceof RegExp ? subject : new RegExp(subject.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, '\\$&'), 'gi');

    while ((match = re.exec(_this.content.text)) !== null) {
      _this.results.push({ length: match[0].length, index: match.index });
    }
    return _this;
  }

  /**
   * Return next available match
   *
   * @returns {TextRange | null} Returns a `TextRange` if a match is available, or `null` if no
   * more matches are available.
   */


  _createClass(TextFinder, [{
    key: 'next',
    value: function next() {
      if (this.current >= this.results.length) {
        return null;
      }

      var match = this.results[this.current];
      var length = match.length;
      var start = this.getAt_(match.index);
      var end = void 0;

      // Re-use start marker descriptor if end offset within bounds of start text node
      if (start.offset + length <= start.marker.node.nodeValue.length) {
        end = (0, _merge2.default)({}, start);
        end.offset = start.offset + length - 1;
      } else {
        end = this.getAt_(match.index + length - 1);
      }

      var range = new _textrange2.default(this.content, start, end);
      ++this.current;

      return range;
    }
  }]);

  return TextFinder;
}(_finder2.default);

exports.default = TextFinder;

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _finder = __webpack_require__(6);

var _finder2 = _interopRequireDefault(_finder);

var _textnodexpath = __webpack_require__(15);

var _textnodexpath2 = _interopRequireDefault(_textnodexpath);

var _textrange = __webpack_require__(4);

var _textrange2 = _interopRequireDefault(_textrange);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Class responsible for locating text in a `TextContent` instance from an
 * XPath representation and start and end offsets.
 */
var XpathFinder = function (_Finder) {
  _inherits(XpathFinder, _Finder);

  /**
   * Class constructor
   *
   * @param {TextContent} content - Reference to `TextContent` instance
   * @param {XpathSubject} subject - Descriptor containing an XPath representation and
   * start and end offsets.
   */
  // FIXME: what type is `subject`?
  function XpathFinder(content, subject) {
    _classCallCheck(this, XpathFinder);

    var _this = _possibleConstructorReturn(this, (XpathFinder.__proto__ || Object.getPrototypeOf(XpathFinder)).call(this, content));
    // Construct base class


    if (subject.start.offset < 0 || subject.end.offset < 0) {
      throw new Error('Invalid or no XPath object specified');
    }

    // Compute text node start and end elements that the XPath representation refers to.
    var end = void 0;
    var xpath = new _textnodexpath2.default(_this.content.root);
    var start = xpath.elementAt(subject.start.xpath);

    // If an element could not be obtained from the XPath representation, abort now (messages will
    // have been output).
    if (start === null) {
      return _possibleConstructorReturn(_this);
    }

    end = xpath.elementAt(subject.end.xpath);
    if (end === null) {
      return _possibleConstructorReturn(_this);
    }

    // Retrieve global character offset of the text node.
    start = content.find(start);
    end = content.find(end);
    if (start < 0 || end < 0) {
      _logger2.default.error('unable to derive global offsets: %d:%d [xpath=%s:%s to end=%s:%s]', start, end, subject.start.xpath, subject.start.offset, subject.end.xpath, subject.end.offset);
      return _possibleConstructorReturn(_this);
    }

    // Retrieve offset markers.
    start = content.at(start).offset + subject.start.offset;
    end = content.at(end).offset + subject.end.offset - 1;

    /* logger.log("DEBUG start = ", start, "end = ", end, subject); */

    if (start > end) {
      throw new Error('Invalid XPath representation: start > end');
    }

    // Save global character offset and relative start and end offsets in descriptor.
    _this.results.push({ start: start, end: end });
    return _this;
  }

  /**
   * Return next available match
   *
   * @returns {TextRange | null} Returns a `TextRange` if a match is available, or `null` if no
   * more matches are available.
   */


  _createClass(XpathFinder, [{
    key: 'next',
    value: function next() {
      if (this.current >= this.results.length) {
        return null;
      }

      var subject = this.results[this.current];
      if (subject == null) {
        throw new Error('Subject not found');
      }
      ++this.current;

      // TODO: we don't necessarily need to invoke getAt_ for the end offset.  A check has to be made
      // to ascertain if the end offset falls within the start node.
      return new _textrange2.default(this.content, this.getAt_(subject.start), this.getAt_(subject.end));
    }
  }]);

  return XpathFinder;
}(_finder2.default);

exports.default = XpathFinder;

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _textrange = __webpack_require__(4);

var _textrange2 = _interopRequireDefault(_textrange);

var _dom = __webpack_require__(1);

var dom = _interopRequireWildcard(_dom);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Positional highlight containment
 *
 * Manages highlights as they appear on the page rather than on the DOM to enable correct cursor
 * movement from highlight to highlight.
 */
var HighlightMarkers = function () {
  function HighlightMarkers() {
    _classCallCheck(this, HighlightMarkers);

    this.markers = [];
  }

  _createClass(HighlightMarkers, [{
    key: 'add',
    value: function add(query, id, hit) {
      var offset = hit.start.marker.offset + hit.start.offset;
      var mid = void 0;
      var min = 0;
      var max = this.markers.length - 1;

      while (min < max) {
        mid = Math.floor((min + max) / 2);

        if (this.markers[mid].offset < offset) {
          min = mid + 1;
        } else {
          max = mid;
        }
      }

      this.markers.splice(this.markers.length > 0 && this.markers[min].offset < offset ? min + 1 : min, 0, { query: query, id: id, offset: offset });
    }
  }, {
    key: 'removeAll',
    value: function removeAll(query) {
      var markers = this.markers;

      for (var i = 0; i < markers.length;) {
        if (markers[i].query === query) {
          markers.splice(i, 1);
        } else {
          ++i;
        }
      }
    }
  }, {
    key: 'get',
    value: function get(index) {
      return this.markers[index] || null;
    }
  }, {
    key: 'calculateTotal',
    value: function calculateTotal(queryNames) {
      if (queryNames == null) {
        return this.markers.length;
      }

      return this.markers.reduce(function (acc, marker) {
        if (queryNames.indexOf(marker.query.name) >= 0) {
          return acc + 1;
        }

        return acc;
      }, 0);
    }
  }, {
    key: 'calculateTotalVisible',
    value: function calculateTotalVisible(queryNames) {
      // Simple fix for now that accounts for when we're running in a JsDOM environment, under which
      // there are never any visible highlights.  This measure prevents tests from failing.
      if (false) {
        return this.calculateTotal(queryNames);
      } else if (queryNames == null) {
        return this.markers.reduce(function (acc, marker) {
          return acc + Number(dom.isHighlightVisible(marker.id));
        }, 0);
      }

      return this.markers.reduce(function (acc, marker) {
        if (queryNames.indexOf(marker.query.name) >= 0 && dom.isHighlightVisible(marker.id)) {
          return acc + 1;
        }

        return acc;
      }, 0);
    }
  }, {
    key: 'find',
    value: function find(at, queryNames) {
      var marker = null;

      this.markers.some(function (m) {
        var q = m.query;

        // Queryset must be enabled and highlight visible.  Note that highlights are never visible
        // in non-browser environments, in which case highlights are assumed to be visible.
        if (!q.enabled) {
          return false;
        } else if (queryNames != null && queryNames.indexOf(q.name) < 0) {
          return false;
        } else if (true && !dom.isHighlightVisible(m.id)) {
          return false;
        } else if (at < 1) {
          marker = m;
          return true;
        }

        --at;
        return false;
      });

      return marker;
    }
  }, {
    key: 'assert',
    value: function assert(expectedSize) {
      var lastOffset = 0;
      var size = 0;

      this.markers.forEach(function (i) {
        if (i.offset < lastOffset || i.id - i.query.highlightId >= i.query.length) {
          throw new Error('Invalid state: highlight out of position');
        }

        lastOffset = i.offset;
        ++size;
      });

      if (size !== expectedSize) {
        throw new Error('Invalid state: size mismatch');
      }
    }
  }]);

  return HighlightMarkers;
}();

exports.default = HighlightMarkers;

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _consts = __webpack_require__(3);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * This class builds XPath representations of text nodes, optionally within a DOM sub-tree.  If a
 * root node is specified, the XPath produced will include the elements up to but **not** including
 * said root node.
 *
 * @param {DOMElement} [root=null] - Root DOM node
 */
var TextNodeXpath = function () {
  function TextNodeXpath(root) {
    _classCallCheck(this, TextNodeXpath);

    this.root = root;
  }

  /**
   * Compute the XPath representation of a text node
   *
   * The XPath produced of the text node is fully normalised and unaffected by the current state of
   * text node fragmentation caused by the presence of highlight containers.
   *
   * Throws an exception if `node` is <strong>not</strong> a text node.
   *
   * @param {Node} node - Text node to compute XPath representation of
   * @returns {string} XPath representation
   */


  _createClass(TextNodeXpath, [{
    key: 'xpathOf',
    value: function xpathOf(node) {
      // Note: no checks required since `indexOfText_´ throws exception if node invalid: null or not
      // like text.
      var xpath = '/text()[' + this.indexOfText_(node) + ']';

      // Skip all text or highlight container nodes
      /* eslint-disable curly */
      for (node = node.parentNode; node != null && node !== this.root && this.isLikeText_(node); node = node.parentNode) {}
      /* eslint-enable curly */

      // Start traversing upwards from `node´'s parent node until we hit `root´ (or null)
      for (; node != null && node !== this.root && node.nodeType === 1; node = node.parentNode) {
        var id = this.indexOfElement_(node);
        xpath = '/' + node.nodeName.toLowerCase() + '[' + id + ']' + xpath;
      }

      if (node == null) {
        throw new Error("Specified node not within root's subtree");
      }

      return xpath;
    }

    /**
     * Compute element referenced by an XPath string
     *
     * The element computed is the same that would result from traversing a DOM sub-tree fully
     * normalised and thus unaffected by text node fragmentation caused by the presence of highlight
     * containers.
     *
     * @param {string} xpath - String containing XPath representation
     * @returns {Node | null} The element referenced by the XPath string or `null` if not found
     * */

  }, {
    key: 'elementAt',
    value: function elementAt(xpath) {
      var parts = xpath.split('/');
      var part = void 0;
      var cur = this.root; /* start from the root node */

      // At an absolute minimum, a XPath representation must be of the form: /text(), which results
      // in `parts´ having a length of 2.
      if (parts[0].length !== 0 || parts.length < 2) {
        throw new Error('Invalid XPath representation');
      }

      // Break up the constituent parts of the XPath representation but discard the first element
      // since it'll be empty due to the starting forward slash in the XPath string.
      var i = 1;
      for (var l = parts.length - 1; i < l; ++i) {
        part = this.xpathPart_(parts[i]);
        cur = this.nthElementOf_(cur, part.tag, part.index);
        if (cur == null) {
          // This, we would hope, would be indicative that the tree mutated.  Otherwise, either this
          // algorithm is flawed or the reverse operation is.
          _logger2.default.error('failed to find nth child:', part, cur);
          return null;
        }
      }

      // Now process the text element given by `parts[i]`.
      part = parts[i].trim();
      if (part.length === 0) {
        throw new Error('XPath part cannot be empty. As an example, the form `//tag` is not currently\nallowed.  Offending XPath representation: ' + xpath);
      }

      part = this.xpathPart_(parts[i]);
      // Casting `cur` to `any` because we check above after mutation and return if `null`
      cur = part.tag === 'text()' ? this.nthTextOf_(cur, part.index) : null;

      if (cur == null || cur.nodeType !== 3) {
        _logger2.default.error('element at specified XPath NOT a text node:', xpath, part, cur);
        return null;
      }

      return cur;
    }

    /**
     * Calculate the relative offset from a specified text node
     * (`node`) to the start of the first **sibling**
     * text node in a set of contiguous text or highlight container nodes.
     *
     * For example, given the post-highlight, non-normalised, child contents
     * of an arbitrary element:
     *
     *   `#text + SPAN.hh-highlight + #text + STRONG`
     *
     * If this method were invoked with `node` containing a
     * reference to the third `#text` element, the computed offset
     * would be the length of the `SPAN` to its left plus the length
     * of the first `#text`.  This because the normalised version --
     * pre-highlight, that is -- of the above would be:
     *
     *   `#text + STRONG`
     *
     * @param {Node} node - Text node
     * @returns {number} Offset of text node
     */

  }, {
    key: 'offset',
    value: function offset(node) {
      var offset = 0;

      if (node == null || node.nodeType !== 3) {
        throw new Error('Invalid or no text node specified');
      }

      /* eslint-disable no-constant-condition */
      // Climb the tree of nested highlight containers in a left to right order, if any, calculating
      // their respective lengths and adding to the overall offset.
      while (true) {
        while (node.previousSibling == null) {
          node = node.parentNode;
          if (node === this.root || node == null) {
            throw new Error('Invalid state: expected highlight container or text node');
          } else if (!this.isHighlight_(node)) {
            return offset;
          } else if (node.previousSibling != null) {
            break;
          }
        }

        node = node.previousSibling;
        if (!this.isLikeText_(node)) {
          break;
        }

        offset += this.length_(node);
      }
      /* eslint-enable no-constant-condition */

      return offset;
    }

    /**
     * Calculate the length of all text nodes in a specified sub-tree
     *
     * Note that no checks are made to ensure that the node is either a
     * highlight container or text node.  Caller is responsible for invoking this
     * method in the right context.
     *
     * @access private
     * @param {Node} node - text node or **highlight** container
     * @returns {number} Combined length of text nodes
     */

  }, {
    key: 'length_',
    value: function length_(node) {
      if (node.nodeType === 3) {
        return node.nodeValue.length;
      }

      // If `node´ isn't of text type, it is *assumed* to be a highlight container.  No checks are
      // made to ensure this is the case.  Caller is responsible!
      var ch = node.childNodes;
      var length = 0;

      // We loop recursively through all child nodes because a single highlight container may be
      // parent to multiple highlight containers.
      for (var i = 0, l = ch.length; i < l; ++i) {
        length += this.length_(ch[i]);
      }

      return length;
    }

    /**
     * Skip to first highlight container parent of a specified node, if it is of text type
     *
     * @param {Node} node - text node.
     * @returns {Node} First highlight container of text node, if applicable.
     */

  }, {
    key: 'skip_',
    value: function skip_(node) {
      // Don't do anything if node isn't of text type
      if (node.nodeType === 3) {
        while (node != null) {
          // Skip to first highlight container element
          var parent = node.parentNode;
          if (parent === this.root || !this.isHighlight_(parent)) {
            break;
          }

          node = parent;
        }
      }

      return node;
    }

    /**
     * Return boolean value indicative of whether a given node is a highlight container
     * @access private
     *
     * @param {Node} node - DOM element to check
     * @returns {boolean} `true` if it is a highlight container
     */

  }, {
    key: 'isHighlight_',
    value: function isHighlight_(node) {
      // NOTE: this is potentially problematic if the document uses class names that contain or are
      // equal to `Css.highlight´.
      return node.nodeName.toLowerCase() === 'span' && node.className.indexOf(_consts.Css.highlight) !== -1;
    }

    /**
     * Return the XPath index of an arbitrary element node, excluding text nodes, relative to its
     * sibling nodes
     *
     * Note that XPath indices are **not** zero-based.
     *
     * @access private
     * @param {Node} node - DOM element to calculate index of
     * @returns {number} Index of node plus one
     */

  }, {
    key: 'indexOfElement_',
    value: function indexOfElement_(node) {
      if (this.isLikeText_(node)) {
        throw new Error('No node specified or node of text type');
      }

      var name = node.nodeName.toLowerCase();
      var index = 1;

      while ((node = node.previousSibling) !== null) {
        // Don't count contiguous text nodes or highlight containers as being nodes.  IOW, contiguous
        // text nodes or highlight containers are treated as ONE element.  Also ignore special
        // document type nodes (e.g. `<!DOCTYPE html>`) for HTML5 documents, to avoid producing an
        // invalid XPath representation of `/html[2]` rather than the expected `/html[1]`.
        if (!this.isLikeText_(node) && node.nodeName.toLowerCase() === name && node.nodeType !== Node.DOCUMENT_TYPE_NODE) {
          ++index;
        }
      }

      return index;
    }

    /**
     * Return the XPath index of an arbitrary **text** node, excluding element nodes, relative to its
     * sibling nodes.
     *
     * Since text nodes are liable to be truncated to enable highlight of a substring of text, this
     * method counts contiguous text nodes and highlight container elements as one, e.g.:
     *
     * ```
     * #text + STRONG + #text + SPAN.highlight
     * ```
     *
     * In the example above, the index of the third node is the same as the
     * fourth node's, or 3.  More clearly:
     *
     * ```
     * 1, 2, 3, 3
     * ```
     *
     * Note that XPath indices are **not** zero-based.
     *
     * @access private
     * @param {Node} node - DOM element to calculate index of.
     * @returns {number} Index of node plus one.
     */

  }, {
    key: 'indexOfText_',
    value: function indexOfText_(node) {
      if (!this.isLikeText_(node)) {
        throw new Error('No node specified or not of text type');
      }

      var index = 1;
      var wast = true;

      node = this.skip_(node);
      while ((node = node.previousSibling) != null) {
        // Don't count contiguous text nodes or highlight containers as being separate nodes.  IOW,
        // contiguous text nodes or highlight containers are treated as ONE element.
        if (this.isLikeText_(node)) {
          if (wast) {
            continue;
          } else {
            wast = true;
          }
          ++index;
        } else {
          wast = false;
        }
      }

      return index;
    }

    /**
     * Return `true` if specified node is either of text type or a highlight container, thus like a
     * text node
     *
     * @param {Node} node - node to check
     * @returns {boolean} - `true` if node is of text type of highlight container
     */

  }, {
    key: 'isLikeText_',
    value: function isLikeText_(node) {
      return node.nodeType === 3 || this.isHighlight_(node);
    }

    /**
     * Return an object map containing a tag and index of an XPath representation part
     *
     * Exceptions may be thrown if the regular expression matcher encounters an unrecoverable error
     * of if the index in the XPath part is less than 1.
     *
     * Object returned is of the form:
     * ```
     * {
     *   tag: string,
     *   index: integer
     * }
     * ```
     *
     * @param {string} part - An XPath representation part; e.g. "div[2]", "text()[3]" or "p"
     * @returns {XPathPart} Object containing tag and index
     */

  }, {
    key: 'xpathPart_',
    value: function xpathPart_(part) {
      var index = void 0;

      // If no index specified: assume first
      if (part.indexOf('[') === -1) {
        return { tag: part.toLowerCase(), index: 0 };
      }

      var matchedPart = void 0;
      // *Attempt* to retrieve element's index.  If an exception is thrown, produce a meaningful
      // error but re-throw since the XPath representation is clearly invalid.
      try {
        // Note that `any` casts below are deliberate since we the code is within a try-catch block.
        var match = part.match(/([^[]+)\[(\d+)\]/);
        index = parseInt(match[2], 10);
        matchedPart = match[1];
        if (--index < 0) {
          throw new Error('Invalid index: ' + index);
        }
      } catch (x) {
        _logger2.default.error('failed to extract child index: ' + part);
        throw x; /* Re-throw after dumping inspectable object. */
      }

      return { tag: matchedPart.toLowerCase(), index: index };
    }

    /**
     * Find the nth child element of a specified node, **excluding** text nodes
     *
     * @param {Node} parent - node whose children to search
     * @param {string} tag - the tag name of the node sought in **lowercase** form
     * @param {integer} index - child index of the node sought
     *
     * @returns {Node | null} The nth element of `node` or `null` if non-existent
     */

  }, {
    key: 'nthElementOf_',
    value: function nthElementOf_(parent, tag, index) {
      var ch = parent.children;
      var node = void 0;

      for (var i = 0, l = ch.length; i < l; ++i) {
        node = ch[i];

        // Skip highlight containers since tag could be `span´, the same as highlight containers.
        if (this.isHighlight_(node)) {
          continue;
        } else if (node.nodeName.toLowerCase() === tag) {
          if (index === 0) {
            return node;
          }
          --index;
        }
      }

      _logger2.default.error('failed to locate tag \'' + tag + '\' at index ' + String(index));
      return null;
    }

    /**
     * Find the nth normalised text node within a specified element node
     *
     * @param {Node} parent - node whose children to search
     * @param {integer} index - child index of the node sought
     *
     * @returns {Node | null} element node or `null` if no match
     */

  }, {
    key: 'nthTextOf_',
    value: function nthTextOf_(parent, index) {
      var node = void 0;
      var wast = false;
      var ch = parent.childNodes;

      for (var i = 0, l = ch.length; i < l; ++i) {
        node = ch[i];

        // Don't count contiguous text or highlight container nodes and ignore non-text nodes
        if (this.isLikeText_(node)) {
          if (wast) {
            continue;
          } else {
            wast = true;
          }
        } else {
          wast = false;
          continue;
        }

        // We have got a potential match when `index´ === 0
        if (index === 0) {
          // Skip to first text node if currently on a highlight container
          while (this.isHighlight_(node)) {
            ch = node.childNodes;
            if (ch.length === 0 || !this.isLikeText_(ch[0])) {
              throw new Error('Invalid state: expected text node or highlight container inside container');
            }

            node = ch[0];
          }

          // Ensure tag sought after is the right one
          if (node.nodeType !== 3) {
            _logger2.default.error('failed to locate text node at index ' + String(index));
            return null;
          }

          return node;
        }

        --index;
      }

      // No match!
      return null;
    }
  }]);

  return TextNodeXpath;
}();

exports.default = TextNodeXpath;

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _merge = __webpack_require__(9);

var _merge2 = _interopRequireDefault(_merge);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

var _selection = __webpack_require__(22);

var selection = _interopRequireWildcard(_selection);

var _htmlhighlighter = __webpack_require__(10);

var _htmlhighlighter2 = _interopRequireDefault(_htmlhighlighter);

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _textrange = __webpack_require__(4);

var _textrange2 = _interopRequireDefault(_textrange);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Support for browser text selections
 *
 * This class is an extension of HTML Highlighter which provides support for browser text
 * selections.
 */
var SelectedRange = function () {
  _createClass(SelectedRange, null, [{
    key: 'fromHtmlHighlighter',
    value: function fromHtmlHighlighter(instance) {
      return new SelectedRange(instance.content);
    }
  }]);

  function SelectedRange(content) {
    _classCallCheck(this, SelectedRange);

    this.content = content;
  }

  /* eslint-disable complexity, max-statements */
  /**
   * Return the current selected text range in the form of a `TextRange` object
   *
   * If there is no selected text, `null` is returned.
   *
   * @returns {TextRange|null} The current selected text range or `null` if it could not be
   * computed.
   */


  _createClass(SelectedRange, [{
    key: 'get',
    value: function get() {
      var sel = window.getSelection();
      if (sel == null) {
        return null;
      }

      var range = sel.getRangeAt(0);
      if (range == null) {
        return null;
      }

      var start = void 0,
          end = void 0;
      try {
        start = selection.getNormalizedStartBoundaryPoint(range);
        end = selection.getNormalizedEndBoundaryPoint(range);
      } catch (x) {
        _logger2.default.error('unable to compute boundary points:', x);
        return null;
      }

      if (start.node.nodeType !== Node.TEXT_NODE || end.node.nodeType !== Node.TEXT_NODE) {
        _logger2.default.info('selection anchor or focus node(s) not text: ignoring');
        return null;
      }

      // Account for selections where the start and end elements are the same *and* whitespace exists
      // longer than one character.  For instance, The element `<p>a   b</p>` is shown as `a b` by
      // browsers with the whitespace rendered collapsed.  This means that in this particular
      // case, it is not possible to simply retrieve the length of the selection's text and use that
      // as the selection's end offset as it would be invalid.  The way to avoid calculating an
      // invalid end offset is by looking at the anchor and focus (start and end) offsets.
      // Strangely, if the selection spans more than one element, one may simply use the length of
      // the selected text regardless of the occurrence of whitespace in between.
      var len = start.node === end.node ? Math.abs(end.offset - start.offset) : sel.toString().length;
      if (len <= 0) {
        return null;
      }

      // Determine start and end indices in text offset markers array
      var startOffset = this.content.find(start.node);
      var endOffset = start.node === end.node ? startOffset : this.content.find(end.node);
      if (startOffset < 0 || endOffset < 0) {
        _logger2.default.error('unable to retrieve offset of selection anchor or focus node(s):', sel.anchorNode, start.node, sel.focusNode, end.node);
        return null;
      }

      // Create start and end range descriptors, whilst accounting for inverse selection where the
      // user selects text in a right to left orientation.
      var startDescr = void 0,
          endDescr = void 0;
      if (startOffset < endOffset || startOffset === endOffset && start.offset < end.offset) {
        startDescr = _textrange2.default.descriptorRel(this.content.at(startOffset), start.offset);

        if (start.node === end.node) {
          endDescr = (0, _merge2.default)({}, startDescr);
          endDescr.offset += len - 1;
        } else {
          endDescr = _textrange2.default.descriptorRel(this.content.at(endOffset), end.offset - 1);
        }
      } else {
        startDescr = _textrange2.default.descriptorRel(this.content.at(endOffset), end.offset);

        if (end.node === start.node) {
          endDescr = (0, _merge2.default)({}, startDescr);
          endDescr.offset += len - 1;
        } else {
          endDescr = _textrange2.default.descriptorRel(this.content.at(startOffset), start.offset - 1);
        }
      }

      return new _textrange2.default(this.content, startDescr, endDescr);
    }
    /* eslint-enable complexity, max-statements */

    /**
     * Clear the current text selection
     *
     * Only the Chrome and Firefox implementations are supported.
     */

  }, {
    key: 'clear',
    value: function clear() {
      // From: http://stackoverflow.com/a/3169849/3001914
      // Note that we don't support IE at all.
      var getSelection = window.getSelection;
      if (getSelection != null) {
        if (getSelection().empty) {
          // Chrome
          getSelection().empty();
          return;
        } else if (getSelection().removeAllRanges) {
          // Firefox
          getSelection().removeAllRanges();
          return;
        }
      }

      _logger2.default.warn('clearing of text selection not supported');
    }
  }]);

  return SelectedRange;
}();

exports.default = SelectedRange;

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = __webpack_require__(8);

var _events2 = _interopRequireDefault(_events);

var _dom = __webpack_require__(1);

var dom = _interopRequireWildcard(_dom);

var _consts = __webpack_require__(3);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

var _highlightmarkers = __webpack_require__(14);

var _highlightmarkers2 = _interopRequireDefault(_highlightmarkers);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Class responsible for managing the state of the highlight cursor
 *
 * Emits the following events:
 *
 *  - clear: cursor position is cleared
 *  - setiterable: allowable iterable queries set or cleared
 *  - update: cursor position mutated
 */
var Cursor = function (_EventEmitter) {
  _inherits(Cursor, _EventEmitter);

  /**
   * Class constructor
   *
   * @param {HighlightMarkers} markers - Reference to highlight markers object
   */
  function Cursor(markers) {
    _classCallCheck(this, Cursor);

    var _this = _possibleConstructorReturn(this, (Cursor.__proto__ || Object.getPrototypeOf(Cursor)).call(this));

    _this.markers = markers;
    _this.index = -1;
    _this.iterableQueries = null;
    _this.total = 0;
    _this.setIterableQueries(null);
    return _this;
  }

  /**
   * Clear the current cursor state and recalculate number of total iterable highlights */


  _createClass(Cursor, [{
    key: 'clear',
    value: function clear() {
      this.clearActive_();
      this.index = -1;
      this.update(true);
      this.emit('clear');
    }

    /**
     * Set or clear the query sets that the cursor can move through
     *
     * When one or more query sets are specified, cursor movement is restricted to the specified
     * query sets.  When setting the cursor offset, the offset will then apply within the context of
     * the active iterable query sets.
     *
     * The restriction can be lifted at any time by passing `null` to the method.
     *
     * @param {IterableQueries | null} queries - An array (or string) containing the query set names
     * or `null` if all query-sets active.
     */

  }, {
    key: 'setIterableQueries',
    value: function setIterableQueries(queries) {
      if (queries == null) {
        this.iterableQueries = null;
      } else if (typeof queries === 'string') {
        this.iterableQueries = [queries];
      } else {
        this.iterableQueries = queries.slice();
      }

      this.clear();
      this.emit('setiterable', queries);
    }

    /**
     * Update the total of iterable highlights
     *
     * Causes recomputation of the total available number of visible highlights and produces the
     * update event if this number changes.  The event can be forcefully produced it `force` is set
     * to `true`.
     *
     * @param { boolean } force - When `true` causes the "update" event to always be emitted
     */

  }, {
    key: 'update',
    value: function update() {
      var force = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      var total = this.markers.calculateTotalVisible(this.iterableQueries);
      if (force || total !== this.total) {
        this.total = total;
        this.emit('update', this.index, this.total);
      }
    }

    /**
     * Set cursor to query referenced by absolute query index
     *
     * @param {number} index - Virtual cursor index
     * @param {boolean} dontRecurse - When `true` instructs the method not to employ recursion
     * @param {ScrollToCallback} scrollTo - Optional custom function to invoke if highlight being
     * moved to is not visible on the page
     *
     * @returns {boolean} `true` if move occurred
     */

  }, {
    key: 'set',
    value: function set(index, dontRecurse, scrollTo) {
      if (index < 0) {
        throw new Error('Invalid cursor index specified: ' + index);
      }

      var marker = this.markers.find(index, this.iterableQueries);

      // If index overflown, set to first highlight
      if (marker == null) {
        if (!dontRecurse) {
          return this.set(0, true);
        }
        return false;
      }

      // Clear currently active highlight, if any, and set requested highlight active
      this.clearActive_();
      var coll = dom.getHighlightElements(marker.id);
      // Scroll viewport if element not visible
      if (coll.length > 0) {
        dom.addClass(coll, _consts.Css.enabled);

        var first = coll[0];
        if (typeof scrollTo === 'function') {
          try {
            scrollTo(first);
          } catch (x) {
            _logger2.default.error('failed to scroll to highlight:', x);
          }
        } else if (!dom.isInView(first)) {
          dom.scrollIntoView(first);
        }
      }

      if (this.index === index) {
        return false;
      }

      this.index = index;
      this.emit('update', index, this.total);
      return true;
    }

    /**
     * Move cursor position to the previous query in the active query set
     *
     * If the cursor moves past the first query in the active query set, the active query set moves
     * to the previous available one and the cursor position to its last query.  If the current query
     * set is the first in the collection and thus it is not possible to move to the previous query
     * set, the last query set is made active instead, thus ensuring that the cursor always rolls
     * over.
     */

  }, {
    key: 'prev',
    value: function prev() {
      if (this.total > 0) {
        this.set((this.index < 1 ? this.total : this.index) - 1, false);
      }
    }

    /**
     * Move cursor position to the next query in the active query set
     *
     * If the cursor moves past the last query in the active query set, the active query set moves to
     * the next available one and the cursor position to its first query.  If the current query set
     * is the last in the collection and thus it is not possible to move to the next query set, the
     * first query set is made active instead, thus ensuring that the cursor always rolls over.
     */

  }, {
    key: 'next',
    value: function next() {
      this.set(this.index + 1, false);
    }

    // Private interface
    // -----------------
    /**
     * Clear the currently active cursor highlight
     *
     * The active cursor highlight is the element or elements at the current cursor position.
     * @access private
     */

  }, {
    key: 'clearActive_',
    value: function clearActive_() {
      var cssEnabled = _consts.Css.enabled;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = dom.getAllHighlightElements(cssEnabled)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var el = _step.value;

          dom.removeClass(el, cssEnabled);
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }]);

  return Cursor;
}(_events2.default);

exports.default = Cursor;

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.finder = undefined;

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _finder = __webpack_require__(6);

var _finder2 = _interopRequireDefault(_finder);

var _textfinder = __webpack_require__(12);

var _textfinder2 = _interopRequireDefault(_textfinder);

var _xpathfinder = __webpack_require__(13);

var _xpathfinder2 = _interopRequireDefault(_xpathfinder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Construct appropriate `Finder`-derived class for a given subject
 *
 * @param {TextContent} content - reference to `TextContent` holding a text representation of the
 * document
 * @param {TextSubject | XpathSubject} subject - subject to find; can be of `string` or `RegExp`
 * type
 *
 * @returns {Finder} finder instance ready for use
 */
function finder(content, subject) {
  // FIXME: employ more robust check below that doesn't assume Xpath finder by default
  return _textfinder2.default.isSubject(subject) ? new _textfinder2.default(content, subject) : new _xpathfinder2.default(content, subject);
}

exports.finder = finder;

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDebugging = exports.setDebugging = exports.getVerbose = exports.setVerbose = exports.SelectedRange = exports.XPathFinder = exports.TextFinder = exports.RangeHighlighter = exports.HtmlHighlighter = undefined;

var _globals = __webpack_require__(5);

var _htmlhighlighter = __webpack_require__(10);

var _htmlhighlighter2 = _interopRequireDefault(_htmlhighlighter);

var _rangehighlighter = __webpack_require__(11);

var _rangehighlighter2 = _interopRequireDefault(_rangehighlighter);

var _textfinder = __webpack_require__(12);

var _textfinder2 = _interopRequireDefault(_textfinder);

var _xpathfinder = __webpack_require__(13);

var _xpathfinder2 = _interopRequireDefault(_xpathfinder);

var _selectedrange = __webpack_require__(16);

var _selectedrange2 = _interopRequireDefault(_selectedrange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// For whatever reason, it is not possible to use the handy `export * from "module"` syntax.
exports.HtmlHighlighter = _htmlhighlighter2.default;
exports.RangeHighlighter = _rangehighlighter2.default;
exports.TextFinder = _textfinder2.default;
exports.XPathFinder = _xpathfinder2.default;
exports.SelectedRange = _selectedrange2.default;
exports.setVerbose = _globals.setVerbose;
exports.getVerbose = _globals.getVerbose;
exports.setDebugging = _globals.setDebugging;
exports.getDebugging = _globals.getDebugging;

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _dom = __webpack_require__(1);

var dom = _interopRequireWildcard(_dom);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Convenience class for removing highlighting
 */
var RangeUnhighlighter = function () {
  function RangeUnhighlighter() {
    _classCallCheck(this, RangeUnhighlighter);
  }

  _createClass(RangeUnhighlighter, [{
    key: 'undo',

    /**
     * Remove highlighting given by its id
     *
     * @param {number} id - ID of the highlight to remove
     */
    value: function undo(id) {
      var coll = dom.getHighlightElements(id);
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = coll[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var el = _step.value;

          var child = void 0;
          while ((child = el.childNodes[0]) != null) {
            el.parentNode.insertBefore(child, el);
          }

          el.remove();
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }]);

  return RangeUnhighlighter;
}();

exports.default = RangeUnhighlighter;

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = __webpack_require__(8);

var _events2 = _interopRequireDefault(_events);

var _logger = __webpack_require__(2);

var _logger2 = _interopRequireDefault(_logger);

var _consts = __webpack_require__(3);

var _finder = __webpack_require__(6);

var _finder2 = _interopRequireDefault(_finder);

var _factory = __webpack_require__(18);

var factory = _interopRequireWildcard(_factory);

var _rangehighlighter = __webpack_require__(11);

var _rangehighlighter2 = _interopRequireDefault(_rangehighlighter);

var _rangeunhighlighter = __webpack_require__(20);

var _rangeunhighlighter2 = _interopRequireDefault(_rangeunhighlighter);

var _textcontent = __webpack_require__(0);

var _textcontent2 = _interopRequireDefault(_textcontent);

var _util = __webpack_require__(7);

var util = _interopRequireWildcard(_util);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Query set renderer abstract base class
 */
var QueryRenderer = function (_EventEmitter) {
  _inherits(QueryRenderer, _EventEmitter);

  function QueryRenderer() {
    _classCallCheck(this, QueryRenderer);

    var _this = _possibleConstructorReturn(this, (QueryRenderer.__proto__ || Object.getPrototypeOf(QueryRenderer)).call(this));

    _this.querySet = null;
    _this.pass = 0;
    _this.done = false;
    return _this;
  }

  _createClass(QueryRenderer, [{
    key: 'prerender',
    value: function prerender() {
      if (this.done) {
        _logger2.default.error('query rendering already done');
        return null;
      } else if (this.pass > 0) {
        throw new Error('rendering already in progress');
      }

      // Instruct client to initialize renderer with query set.  Note that client may abort
      // rendering.
      this.emit('init');
      var q = this.querySet;
      if (this.done) {
        return null;
      } else if (q == null) {
        this.abort();
        return null;
      }

      return this.querySet;
    }
  }, {
    key: 'render',
    value: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_content) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                util.abstract();

              case 1:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function render(_x) {
        return _ref.apply(this, arguments);
      }

      return render;
    }()
  }, {
    key: 'abort',
    value: function abort() {
      if (!this.done) {
        _logger2.default.log('aborting query render:', this.getQuerySetName());
        this.done = true;
        this.end('abort');
      }
    }
  }, {
    key: 'init',
    value: function init(querySet) {
      if (!this.done && this.pass < 1) {
        this.querySet = querySet;
      }
    }
  }, {
    key: 'end',
    value: function end(event) {
      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      this.emit.apply(this, [event].concat(args));
      this.emit('end');
    }
  }, {
    key: 'getQuerySetName',
    value: function getQuerySetName() {
      return this.querySet != null ? this.querySet.name : '<unknown>';
    }
  }]);

  return QueryRenderer;
}(_events2.default);

/**
 * Query set highlighter
 *
 * Concerned with rendering a particular query set.
 */


var QueryHighlighter = function (_QueryRenderer) {
  _inherits(QueryHighlighter, _QueryRenderer);

  function QueryHighlighter(queries, options) {
    _classCallCheck(this, QueryHighlighter);

    var _this2 = _possibleConstructorReturn(this, (QueryHighlighter.__proto__ || Object.getPrototypeOf(QueryHighlighter)).call(this));

    _this2.queries = queries;
    _this2.options = options;
    _this2.reserve = null;
    _this2.count = 0;
    return _this2;
  }

  _createClass(QueryHighlighter, [{
    key: 'render',
    value: function () {
      var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(content) {
        var q, csscl, highlighter, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, subject, finder;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                q = this.prerender();

                if (!(q == null)) {
                  _context2.next = 3;
                  break;
                }

                return _context2.abrupt('return');

              case 3:

                this.reserve = q.reserve != null && q.reserve > 0 ? q.reserve - q.length : null;

                csscl = null;

                if (this.options.useQueryAsClass) {
                  csscl = _consts.Css.highlight + '-' + q.name;
                }

                highlighter = new _rangehighlighter2.default(q.queryId, q.highlightId + q.length, q.enabled, csscl);

                // For each query, perform a lookup in the internal text representation and highlight each hit.
                // The global offset of each highlight is recorded by the `markers´ object.  The offset
                // is used by the `Cursor´ class to compute the next/previous highlight to show.

                _iteratorNormalCompletion = true;
                _didIteratorError = false;
                _iteratorError = undefined;
                _context2.prev = 10;
                _iterator = this.queries[Symbol.iterator]();

              case 12:
                if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                  _context2.next = 29;
                  break;
                }

                subject = _step.value;
                finder = void 0;
                _context2.prev = 15;

                finder = factory.finder(content, subject);
                _context2.next = 23;
                break;

              case 19:
                _context2.prev = 19;
                _context2.t0 = _context2['catch'](15);

                _logger2.default.exception('subject finder instantiation failed [query=' + q.name + ']: subject:', subject, _context2.t0);
                return _context2.abrupt('return');

              case 23:

                _logger2.default.log('processing subject:', subject);
                _context2.next = 26;
                return this.begin(content, finder, highlighter, subject);

              case 26:
                _iteratorNormalCompletion = true;
                _context2.next = 12;
                break;

              case 29:
                _context2.next = 35;
                break;

              case 31:
                _context2.prev = 31;
                _context2.t1 = _context2['catch'](10);
                _didIteratorError = true;
                _iteratorError = _context2.t1;

              case 35:
                _context2.prev = 35;
                _context2.prev = 36;

                if (!_iteratorNormalCompletion && _iterator.return) {
                  _iterator.return();
                }

              case 38:
                _context2.prev = 38;

                if (!_didIteratorError) {
                  _context2.next = 41;
                  break;
                }

                throw _iteratorError;

              case 41:
                return _context2.finish(38);

              case 42:
                return _context2.finish(35);

              case 43:

                this.done = true;
                this.end('done', this.count);

              case 45:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[10, 31, 35, 43], [15, 19], [36,, 38, 42]]);
      }));

      function render(_x2) {
        return _ref2.apply(this, arguments);
      }

      return render;
    }()
  }, {
    key: 'begin',
    value: function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(content, finder, highlighter, subject) {
        var _this3 = this;

        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', new Promise(function (resolve) {
                  _this3.onRender(content, finder, highlighter, subject, resolve);
                }));

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function begin(_x3, _x4, _x5, _x6) {
        return _ref3.apply(this, arguments);
      }

      return begin;
    }()
  }, {
    key: 'onRender',
    value: function onRender(content, finder, highlighter, subject, resolve) {
      var _this4 = this;

      var hit = void 0;
      var _options$rendering = this.options.rendering,
          isAsync = _options$rendering.async,
          interval = _options$rendering.interval;

      var deferTime = isAsync ? Date.now() + interval : 0;

      ++this.pass;
      _logger2.default.log('rendering pass #' + this.pass + ' [' + this.getQuerySetName() + ']');

      while ((hit = finder.next()) != null) {
        if (this.reserve != null && this.count >= this.reserve) {
          _logger2.default.error('highlight reserve exceeded');
          break;
        }

        _logger2.default.log('highlighting:', hit);

        try {
          // $FlowFixMe: `hit` cannot be `null` here as per condition in `while` above
          var id = highlighter.do(hit);

          // Notify observers of creation of new highlight
          this.emit('highlight', hit, id, subject.state);
          ++this.count;
        } catch (x) {
          _logger2.default.exception('highlighting failed [query=' + this.getQuerySetName() + ']: subject:', subject, x);
        }

        if (isAsync && Date.now() >= deferTime) {
          requestAnimationFrame(function () {
            return _this4.onRender(content, finder, highlighter, subject, resolve);
          });
          return;
        }
      }

      resolve();
    }
  }]);

  return QueryHighlighter;
}(QueryRenderer);

/**
 * Query set unhighlighter
 *
 * Concerned with removing all highlights associated with a particular query set.
 */


var QueryUnhighlighter = function (_QueryRenderer2) {
  _inherits(QueryUnhighlighter, _QueryRenderer2);

  function QueryUnhighlighter() {
    _classCallCheck(this, QueryUnhighlighter);

    return _possibleConstructorReturn(this, (QueryUnhighlighter.__proto__ || Object.getPrototypeOf(QueryUnhighlighter)).apply(this, arguments));
  }

  _createClass(QueryUnhighlighter, [{
    key: 'render',


    // TODO(mg): current algoritum is insufficient because it does not support async mechanics (see
    // QueryHighlighter::render).
    value: function () {
      var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_content) {
        var q, unhighlighter, id, l;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                q = this.prerender();

                if (!(q == null)) {
                  _context4.next = 3;
                  break;
                }

                return _context4.abrupt('return');

              case 3:

                ++this.pass;
                unhighlighter = new _rangeunhighlighter2.default();


                for (id = q.highlightId, l = id + q.length; id < l; ++id) {
                  unhighlighter.undo(id);
                  this.emit('unhighlight', id);
                }

                this.done = true;
                this.end('done');

              case 8:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function render(_x7) {
        return _ref4.apply(this, arguments);
      }

      return render;
    }()
  }]);

  return QueryUnhighlighter;
}(QueryRenderer);

/**
 * Master renderer component
 *
 * Responsible for managing rendering of individual query sets.
 */


var Renderer = function (_EventEmitter2) {
  _inherits(Renderer, _EventEmitter2);

  function Renderer(options) {
    _classCallCheck(this, Renderer);

    var _this6 = _possibleConstructorReturn(this, (Renderer.__proto__ || Object.getPrototypeOf(Renderer)).call(this));

    _this6.onNext = function () {
      _this6.active = null;
      _this6.next();

      // Signal completion of last rendering queue if not rendering anything right now.
      if (_this6.active == null) {
        _this6.emit('done');
      }
    };

    _this6.options = options;
    _this6.queue = [];
    _this6.active = null;
    _this6.content = null;

    _logger2.default.log('async rendering mode: ' + String(_this6.options.rendering.async));
    return _this6;
  }

  _createClass(Renderer, [{
    key: 'setContent',
    value: function setContent(content) {
      this.content = content;
    }
  }, {
    key: 'add',
    value: function add(name, queries) {
      var _this7 = this;

      var renderer = new QueryHighlighter(queries, this.options);
      renderer.on('highlight', function (hit, id, state) {
        _this7.emit('highlight', renderer.querySet, hit, id, state);
      });

      this.enqueue(renderer);
      return renderer;
    }
  }, {
    key: 'remove',
    value: function remove() {
      var _this8 = this;

      var renderer = new QueryUnhighlighter();
      renderer.on('unhighlight', function (id) {
        _this8.emit('unhighlight', id);
      });

      this.enqueue(renderer);
      return renderer;
    }
  }, {
    key: 'next',
    value: function next() {
      if (this.queue.length < 1 || this.active != null || this.content == null) {
        return;
      }

      var active = this.active = this.queue[0];
      active.once('end', this.onNext);
      // $FlowFixMe: `content` guaranteed not `null` here
      active.render(this.content);
    }
  }, {
    key: 'wait',
    value: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        var _this9 = this;

        var active;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                active = this.active;

                if (!(active == null)) {
                  _context5.next = 3;
                  break;
                }

                return _context5.abrupt('return');

              case 3:
                _context5.next = 5;
                return new Promise(function (resolver) {
                  return _this9.once('done', resolver);
                });

              case 5:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function wait() {
        return _ref5.apply(this, arguments);
      }

      return wait;
    }()
  }, {
    key: 'enqueue',
    value: function enqueue(renderer) {
      var _this10 = this;

      var cleanup = function cleanup() {
        _logger2.default.log(renderer.constructor.name + ': rendering done [' + renderer.getQuerySetName() + ']');
        var idx = _this10.queue.indexOf(renderer);
        _this10.queue.splice(idx, 1);
      };

      renderer.once('end', cleanup);
      this.queue.push(renderer);
    }
  }]);

  return Renderer;
}(_events2.default);

exports.default = Renderer;

/***/ }),
/* 22 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getNormalizedEndBoundaryPoint = exports.getNormalizedStartBoundaryPoint = undefined;

var _dom = __webpack_require__(1);

function getNormalizedStartBoundaryPoint(range) {
  var node = void 0,
      offset = void 0;
  node = range.startContainer;
  offset = range.startOffset;

  if (node.nodeType !== Node.TEXT_NODE) {
    node = node.childNodes[offset];
    if (node == null) {
      throw new Error('[InvalidNodeTypeError] Invalid start container');
    }
  }

  return { node: node, offset: offset };
}

function getNormalizedEndBoundaryPoint(range) {
  var node = void 0,
      offset = void 0;
  node = range.endContainer;
  offset = range.endOffset;

  if (node.nodeType === Node.TEXT_NODE) {
    return { node: node, offset: offset };
  }

  var children = node.childNodes;
  var length = children.length;

  // The standard [0] states that the setEndAfter(node) method, when invoked, must run these steps:
  //
  //   1. Let parent be node’s parent.
  //   2. If parent is null, then throw an "InvalidNodeTypeError" DOMException.
  //   3. Set the end of the context object to boundary point (parent, node’s index plus 1).
  //
  // However, in respect to setting the start or end of a range to a boundary point, it further
  // states that:
  //
  //   1. If node is a doctype, then throw an "InvalidNodeTypeError" DOMException.
  //   2. If offset is greater than node’s length, then throw an "IndexSizeError" DOMException.
  //
  // The testcase "onpremWrappedHighlightByChild" [1] tests for a specific case whereby the offset
  // of the end node can, in some circumstances, be equal to the node's (contained children)
  // length.  For instance, consider the following HTML snippet:
  //
  //     <p><span class="target">located in </span><span class="website-entity-class" title="Entity
  // type: City"><span class="target">Boston</span></span></p>
  //
  // ... and then running:
  //
  //    const range = document.createRange();
  //    range.setStartBefore(document.querySelector('.target'));
  //    range.setEndAfter(document.querySelector('.target:last-child'));
  //
  // ... which produces a range where the end container/offset are:
  //
  //    endContainer: span.website-entity-class
  //    endOffset: 1
  //
  // ... however, document.querySelector('span.website-entity-class').childNode.length === 1
  //
  // This is significant because a range's offset is 0-based.  Special logic to account for this is
  // given below.
  //
  // [0] https://dom.spec.whatwg.org/#concept-range-bp-set
  // [1] in `./StarringSelectionNormalizer.testcases.js`
  if (offset > length) {
    throw new Error('[InvalidNodeTypeError] Invalid end container');
  } else if (offset === length) {
    // Attempt to find the last available text node as required by the normalizer, but do not fail
    // if not possible.
    node = (0, _dom.findLastTextNode)(node);
    if (node == null) {
      // Revert to given end container.
      node = range.endContainer;
      offset = 0;
    } else {
      offset = node.textContent.length;
    }
  } else {
    node = node.childNodes[offset];
    offset = 0;
  }

  return { node: node, offset: offset };
}

exports.getNormalizedStartBoundaryPoint = getNormalizedStartBoundaryPoint;
exports.getNormalizedEndBoundaryPoint = getNormalizedEndBoundaryPoint;

/***/ }),
/* 23 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Convenient class for visiting all text nodes that are siblings and descendants of a given root
 * node
 */
var TextNodeVisitor = function () {

  /**
   * Class constructor
   *
   * @param {Node} node - The node where to start visiting the DOM
   * @param {Node} [root=null] - The root node where to stop visiting the DOM
   */
  function TextNodeVisitor(node, root) {
    _classCallCheck(this, TextNodeVisitor);

    if (root == null) {
      if (document.body == null) {
        throw new Error('document body not defined');
      }

      this.root = document.body;
    } else {
      this.root = root;
    }

    this.current = node;
  }

  /**
   * Get the next text node
   *
   * @returns {Node} The next text node or `null` if none found
   */


  _createClass(TextNodeVisitor, [{
    key: 'next',
    value: function next() {
      var cur = this.current;
      if (cur == null || cur.nodeType !== 3) {
        throw new Error('No current node or not text node');
      }

      // Using `any` below to silence flow because of sanity check above
      var node = this.nextNode_(this.current);
      return node != null ? this.current = this.nextText_(node) : null;
    }

    // Private interface
    // -----------------
    /**
     * Get next node
     *
     * Gets the next node, text or otherwise, that is either a sibling or parent to a given node.
     *
     * @param {Node | null} node - current node
     * @returns {Node} next - node or `null` if none available or the root node was reached
     */

  }, {
    key: 'nextNode_',
    value: function nextNode_(node) {
      // Abort if invalid or root node; otherwise attempt to advance to sibling node
      if (node == null) {
        throw new Error('Invalid state: outside of root sub-tree');
      } else if (node === this.root) {
        return null;
      } else if (node.nextSibling != null) {
        return node.nextSibling;
      }

      // Move up to sibling of parent node
      return this.nextNode_(node.parentNode);
    }

    /**
     * Get next text node
     *
     * Get the next available text node that is either a descendant, sibling or otherwise, of a given
     * node.
     *
     * @param {Node} node - current node.
     * @returns {Node} next - node or `null` if none available or the root node was reached
     */

  }, {
    key: 'nextText_',
    value: function nextText_(node) {
      if (node === this.root || node.nodeType === 3) {
        return node;
      }

      var ch = node.childNodes;
      if (ch.length > 0) {
        return this.nextText_(ch[0]);
      }

      var next = this.nextNode_(node);
      return next != null ? this.nextText_(next) : null;
    }
  }]);

  return TextNodeVisitor;
}();

exports.default = TextNodeVisitor;

/***/ }),
/* 24 */
/***/ (function(module, exports) {

module.exports = function(module) {
	if(!module.webpackPolyfill) {
		module.deprecate = function() {};
		module.paths = [];
		// module.parent = undefined by default
		if(!module.children) module.children = [];
		Object.defineProperty(module, "loaded", {
			enumerable: true,
			get: function() {
				return module.l;
			}
		});
		Object.defineProperty(module, "id", {
			enumerable: true,
			get: function() {
				return module.i;
			}
		});
		module.webpackPolyfill = 1;
	}
	return module;
};


/***/ })
/******/ ]);
});
//# sourceMappingURL=htmlhighlighter.js.map